
//var inputArray = [];
//var exportFileHeaders;
//var selectedExportFieldIndices = [];
//var separator;
//var exportFile;
//var exportFileName;
var payloadGlobal;  //Old (currently in use) ->
var global_payload; //New
var global_exportFileName;
var global_exportObjectArray;

function checkInputStatus() {
	if (inputArray.length === 0) {
		fileDialog();
	}
}

function inspect(payload) {

	document.getElementById('data-inspector-placeholder').innerHTML = '';
	document.getElementById('timeline-button-placeholder').innerHTML = '';
	
	inputArray = payload;

	//console.log(inputArray);
	
	//File selector
	var parent;
	var fileName;
	var fileIdentifierIndex;
	var FILE_SELECTOR_OPTIONS = '';
	for (var jsonDoc in payload) {
		//console.log(payload[jsonDoc]);
		//parent = JSON.parse(payload[jsonDoc].toString());
		parent = JSON.parse(payload[jsonDoc]);
		//parent = payload[jsonDoc];
		//console.log(parent);
		fileName = parent['filename'];
		fileIdentifierIndex = fileName.indexOf('.mom');
		fileName = fileName.substring(0, fileIdentifierIndex);
		//console.log(fileName);
		FILE_SELECTOR_OPTIONS += '<option value="' + jsonDoc + '">' + fileName.toUpperCase() + '</option>';
		//console.log(Object.keys(payload[jsonDoc]));
	}
	
	var docCount = inputArray.length;
	var exportButtonText;
	if (docCount === 1) {
		exportButtonText = 'Export 1 document';
	} else {
		exportButtonText = 'Export ' + docCount + ' documents';
	}
	
	//alert (docCount);
	//console.log(FILE_SELECTOR_OPTIONS);
	
	var fileSelector = '<div class="field">' +
			           '<label for="file-selector">Inspect a document</label>' +
			           '<div class="select-wrapper">' +
			           '<select name="file-selector" id="file-selector" onchange="documentPreview(this)">' +
			           '<option value="null">-</option>' +
			           FILE_SELECTOR_OPTIONS + 
			           '</select>' +
			           '</div>' +
			           '</div>' +
				       '<br>';	
	
	document.getElementById('page-header').innerHTML = 'Inspect';
	document.getElementById('file-selector-placeholder').innerHTML = fileSelector;
	document.getElementById('upload-inspect-button').innerHTML = 'Inspect';
	document.getElementById('exportButton').innerHTML = '<a  id="exportpageBuilder" class="button">' + exportButtonText + '</a>';
	
	document.getElementById("exportpageBuilder").addEventListener("click", function() {
		exportpageSpinner(payload);
		//exportpageBuilder(payload);
	}, false);
}

function timelineView() {

	var timelineWindow = window.open('timeline.html');
	timelineWindow.payload = payloadGlobal;
}

function timelineDemoView() {

	var timelineWindow = window.open('timelinedemo.html');
	timelineWindow.payload = payloadGlobal;
}

function documentPreview(element) {

	//alert(element.value);
	//alert(inputArray.length);
	
	console.clear();
	
	//Nothing selected -> Clear view
	if (element.value === 'null') {
		document.getElementById('timeline-button-placeholder').innerHTML = '';
		document.getElementById('data-inspector-placeholder').innerHTML = '';
		return;
	}
	
	var payload = inputArray[element.value];
	console.log(payload);
	
	payloadGlobal = payload;
	
	var timelineButtonString = '<section>' + 
							   '<ul class="actions">' +
							   '<div id="timeline-button-demo">' +
							   '<li><a class="button" onclick="timelineDemoView()">Timeline view (demo mode)</a></li>' + 
							   '</div>' +
							   '</ul>' +
							   '</section>' +
							   '<section>' + 
							   '<ul class="actions">' +
							   '<div id="timeline-button">' +
							   '<li><a class="button" onclick="timelineView()">Timeline view (development mode)</a></li>' + 
							   '</div>' +
							   '</ul>' +
							   '</section>';
	
	timelineButtonString = 	'<section>' + 
							'<ul class="actions">' +
							'<div id="timeline-button">' +
							'<li><a class="button" onclick="timelineView()">Timeline view (experimental)</a></li>' + 
							'</div>' +
							'</ul>' +
							'</section>';
							
	if (OPERATIONAL_MONITORING_MACHINE_getWorkTimeObjectType(payload) === 'INDIVIDUAL') {
		document.getElementById('timeline-button-placeholder').innerHTML = timelineButtonString;
	} else {
		document.getElementById('timeline-button-placeholder').innerHTML = "";
	}
	
	document.getElementById('data-inspector-placeholder').innerHTML = '';
	
	var jsonObject;
	
	var jsonReturnType;
	
	var preview = [];
	
	//DEPRECATED
	//preview.push('<h4>OPERATIONAL MONITORING</h4>');
	
	//FINAL INSPECTOR AND EXPORT FORMAT
	
	//SITE AND IDENTIFIER DATA
	preview.push(tableBuilder('TABLE_TOP', 'site-and-identifier', '<b>1. Site and identifier data</b>'));
	preview.push(rowBuilder('Machine ID', OPERATIONAL_MONITORING_MACHINE_getValue(payload, 'MachineKey')));
	preview.push(rowBuilder('Machine base manufacturer', OPERATIONAL_MONITORING_MACHINE_getValue(payload, 'MachineBaseManufacturer')));
	preview.push(rowBuilder('Machine category', OPERATIONAL_MONITORING_MACHINE_CATEGORY_getValue(payload)));
	preview.push(rowBuilder('Site ID', ''));
	preview.push(rowBuilder('Start time on site', getMachineWorkTimeStartTime(payload)));
	preview.push(rowBuilder('End time on site', getMachineWorkTimeEndTime(payload)));
	preview.push(rowBuilder('Customer', OPERATIONAL_MONITORING_MACHINE_OBJECT_DEFINITION_getLoggingOrganisation(payload)));
	var loggingForm = OPERATIONAL_MONITORING_MACHINE_OBJECT_DEFINITION_getLoggingForm(payload);
	var loggingFormCode = '';
	var loggingFormDescription = '';
	if (loggingForm) {
		loggingFormCode = loggingForm.LoggingFormCode;
		loggingFormDescription = loggingForm.LoggingFormDescription;
	}
	preview.push(rowBuilder('Logging form', loggingFormCode + ' ' + loggingFormDescription));
	var operatorKeyArray = OPERATIONAL_MONITORING_MACHINE_getOperatorKeys(payload);
	preview.push(rowBuilder('Operator count', operatorKeyArray.length));
	for (var operatorKeyIndex in operatorKeyArray) {
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' name', getOperatorName(payload, operatorKeyArray[operatorKeyIndex])));
	}
	var machineCategory = OPERATIONAL_MONITORING_MACHINE_CATEGORY_getValue(payload);
	machineCategory = machineCategory.toUpperCase();
	var sumOfDrivenDistance;
	var forwarderLoadCount;
	for (var operatorKeyIndex in operatorKeyArray) {
		//preview.push(rowBuilder('<b>Driven distance by operator ' + operatorKeyArray[operatorKeyIndex] + '</b>',''));
		if (machineCategory === 'FORWARDER') {
			//console.log('Machine category is forwarder');
			if(getSumOfForwarderLoadCount(payload, operatorKeyArray[operatorKeyIndex]) > 0) {
				//console.log('Has forwarder loads');
				forwarderLoadCount = getSumOfForwarderLoadCount(payload, operatorKeyArray[operatorKeyIndex]);
				//console.log('Forwarder load count: ' + forwarderLoadCount);
				sumOfDrivenDistance = getSumOfDrivenDistance(payload, operatorKeyArray[operatorKeyIndex]);
				//console.log('Forwarder driven distance: ' + sumOfDrivenDistance);
				preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' forwarder total driven distance', sumOfDrivenDistance));
				preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' forwarder total load count', forwarderLoadCount));
				preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' mean driven distance divided by 2', (sumOfDrivenDistance/forwarderLoadCount)/2));
				//preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' driven distance', sumOfDrivenDistance + ' meters')); 
			} else {
				//console.log('Does not have forwarder loads');
				forwarderLoadCount = getSumOfForwarderLoadCount(payload, operatorKeyArray[operatorKeyIndex]);
				//console.log('Forwarder load count: ' + forwarderLoadCount);
				sumOfDrivenDistance = getSumOfDrivenDistance(payload, operatorKeyArray[operatorKeyIndex]);
				//console.log('Forwarder driven distance: ' + sumOfDrivenDistance);
				preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' forwarder total driven distance', sumOfDrivenDistance));
				preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' forwarder total load count', forwarderLoadCount));
				preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] +  ' mean driven distance divided by 2', '-'));
				//preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' driven distance', sumOfDrivenDistance + ' meters')); 
			}
		}
		if (machineCategory === 'HARVESTER') {
			//console.log('Machine category is harvester');
			sumOfDrivenDistance = getSumOfDrivenDistance(payload, operatorKeyArray[operatorKeyIndex]);
			//console.log('Harvester driven distance: ' + sumOfDrivenDistance);
			preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' harvester total driven distance', sumOfDrivenDistance));
			//preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' driven distance', sumOfDrivenDistance + ' meters')); 
		}
	}
	preview.push(tableBuilder('TABLE_BOTTOM', null, null));
	
	//SETTINGS DATA
	preview.push(tableBuilder('TABLE_TOP', 'settings', '<b>2. Settings</b>'));
	var monitoringSettingsObject = OPERATIONAL_MONITORING_MACHINE_getMonitoringSettings(payload); 
	if (OPERATIONAL_MONITORING_MACHINE_getMonitoringSettingsReturnType(payload) === 'Object') {
		preview.push(rowBuilder('Filter time down', OPERATIONAL_MONITORING_MACHINE_MONITORING_SETTINGS_getMonitoringFilterTimeDown(monitoringSettingsObject)));
		preview.push(rowBuilder('Filter time run', OPERATIONAL_MONITORING_MACHINE_MONITORING_SETTINGS_getMonitoringFilterTimeRun(monitoringSettingsObject)));
		preview.push(rowBuilder('Filter time minimum', OPERATIONAL_MONITORING_MACHINE_MONITORING_SETTINGS_getMonitoringFilterTimeMinimum(monitoringSettingsObject)));
	}
	if (OPERATIONAL_MONITORING_MACHINE_getMonitoringSettingsReturnType(payload) === 'Array') {
		preview.push(rowBuilder('Filter time down', OPERATIONAL_MONITORING_MACHINE_MONITORING_SETTINGS_getMonitoringFilterTimeDown(monitoringSettingsObject[0])));
		preview.push(rowBuilder('Filter time run', OPERATIONAL_MONITORING_MACHINE_MONITORING_SETTINGS_getMonitoringFilterTimeRun(monitoringSettingsObject[0])));
		preview.push(rowBuilder('Filter time minimum', OPERATIONAL_MONITORING_MACHINE_MONITORING_SETTINGS_getMonitoringFilterTimeMinimum(monitoringSettingsObject[0])));
	}
	preview.push(tableBuilder('TABLE_BOTTOM', null, null));
	
	//RECORDED TIME DATA
	var planningTime = 0;
	preview.push(tableBuilder('TABLE_TOP', 'recorded-time', '<b>3. Recorded time</b>'));
	preview.push(rowBuilder('<b>Operator work time categories</b>', '<b>Hours</b>'));
	for (var operatorKeyIndex in operatorKeyArray) {
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Machine work', getSecondsInHours(getOperatorWorkTimeInCategory(payload, 'MachineWorkTime', operatorKeyArray[operatorKeyIndex]))));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Meal break', getSecondsInHours(getOperatorWorkTimeInCategory(payload, 'Meal break', operatorKeyArray[operatorKeyIndex]))));
		planningTime = getOperatorWorkTimeInCategory(payload, 'Planning outside machine', operatorKeyArray[operatorKeyIndex]);
		planningTime += getOperatorWorkTimeInCategory(payload, 'Other work outside machine', operatorKeyArray[operatorKeyIndex]);
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Planning outside machine', getSecondsInHours(planningTime)));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Travelling to work outside machine', getSecondsInHours(getOperatorWorkTimeInCategory(payload, 'Travelling to work outside machine', operatorKeyArray[operatorKeyIndex]))));
	}
	preview.push(rowBuilder('<b>Machine work time categories</b>', '<b>Hours</b>'));
	var machineProcessing = 0;
	var machineTerrainTravel = 0;
	var machineTerrainTravel_15 = 0;
	var machineOtherWork = 0;
	var machineOtherWork_15 = 0;
	var machineDownTime = 0;
	var machineDownTime_15 = 0;
	for (var operatorKeyIndex in operatorKeyArray) {
		//console.log('Machine work time debug: ' + getMachineWorkTimeInCategory(payload, 'Processing', operatorKeyArray[operatorKeyIndex]));
		machineProcessing = getSecondsInHours(getMachineWorkTimeInCategory(payload, 'Processing', operatorKeyArray[operatorKeyIndex]));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Processing', machineProcessing));
		machineTerrainTravel = getSecondsInHours(getMachineWorkTimeInCategory(payload, 'Terrain travel', operatorKeyArray[operatorKeyIndex]));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Terrain travel', machineTerrainTravel));
		machineTerrainTravel_15 = getSecondsInHours(getFilteredMachineWorkTimeInCategory(payload, 'Terrain travel', operatorKeyArray[operatorKeyIndex], 900));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Terrain travel (<15)', machineTerrainTravel_15));
		machineOtherWork = getSecondsInHours(getMachineWorkTimeInCategory(payload, 'Other work', operatorKeyArray[operatorKeyIndex]));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Other work', machineOtherWork));
		machineOtherWork_15 = getSecondsInHours(getFilteredMachineWorkTimeInCategory(payload, 'Other work', operatorKeyArray[operatorKeyIndex], 900));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Other work (<15)', machineOtherWork_15));
		machineDownTime = getSecondsInHours(getMachineDownTime(payload, operatorKeyArray[operatorKeyIndex]));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Down time', machineDownTime));
		machineDownTime_15 = getSecondsInHours(getFilteredMachineDownTime(payload, operatorKeyArray[operatorKeyIndex], 900));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Down time (<15)', machineDownTime_15));
		// MACHINE UTILISED TIME
		// MachineRunTime (processing + terrain travel + other work) + MachineDownTime Math.round( (seconds/3600) * 100 ) / 100;
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Machine utilised time', Math.round( (machineProcessing + machineTerrainTravel + machineOtherWork + machineDownTime) * 100 ) / 100 ));	
		// MACHINE EFFECTIVE WORK TIME
		// Processing+(MachineDownTime<15 min)+(TerrainTravel<15 min)+(OtherWork<15min)
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Machine effective work time', Math.round( (machineProcessing + machineDownTime_15 + machineTerrainTravel_15 + machineOtherWork_15) * 100 ) / 100 ));
		// MACHINE PRODUCTIVE WORK TIME 
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Machine productive work time', machineProcessing));
		
	}
	
	preview.push(rowBuilder('<b>Machine down time categories</b>', '<b>Hours</b>'));
	var downTimeCategory;
	var downTimeStandardCode;
	var downTimeInSeconds;
	var downTimeObjects;
	var downTimeJSON;
	
	var sumRepair = 0;
	var sumRepair15 = 0;
	var sumMaintenance = 0;
	var sumMaintenance15 = 0;
	var sumDisturbance = 0;
	var sumDisturbance15 = 0;
	var sumOther = 0;
	var sumOther15 = 0;
	
	var sumWaitingForRepair = 0;
	var sumWaitingForRepair15 = 0;
	var sumPlanningOrFollowUp = 0;
	var sumPlanningOrFollowUp15 = 0;
	var sumAdministrationTelephone = 0;
	var sumAdministrationTelephone15 = 0;
	var sumUnproductiveTerrainWork = 0;
	var sumUnproductiveTerrainWork15 = 0;
	var sumTrailerTransportation = 0;
	var sumTrailerTransportation15 = 0;

	for (var operatorKeyIndex in operatorKeyArray) {
		downTimeObjects = getDownTimeArray(payload, operatorKeyArray[operatorKeyIndex]);
		for (var downTimeIndex in downTimeObjects) {
			downTimeObject = downTimeObjects[downTimeIndex];
			downTimeJSON = JSON.parse(downTimeObject);
			downTimeCategory = downTimeJSON.downTimeCategory;
			downTimeStandardCode = downTimeJSON.downTimeStandardCode;
			downTimeInSeconds = downTimeJSON.downTimeInSeconds;
			switch(downTimeCategory) {
				case 'Repair':
					sumRepair += downTimeInSeconds;
					if (downTimeInSeconds >= 900) {
						sumRepair15 += downTimeInSeconds;
					}
					break;
				case 'Maintenance':
					sumMaintenance += downTimeInSeconds;
					if (downTimeInSeconds >= 900) {
						sumMaintenance15 += downTimeInSeconds;
					}
					break;
				case 'Disturbance':
					sumDisturbance += downTimeInSeconds;
					if (downTimeInSeconds >= 900) {
						sumDisturbance15 += downTimeInSeconds;
					}
					break;
				case 'Other':
					sumOther += downTimeInSeconds;
					if (downTimeInSeconds >= 900) {
						sumOther15 += downTimeInSeconds;
					}
					break;
			}
			
			switch (downTimeStandardCode) {
				case 'Waiting for repair':
					sumWaitingForRepair += downTimeInSeconds;
					if (downTimeInSeconds >= 900) {
						sumWaitingForRepair15 += downTimeInSeconds;
					}
					break;
				case 'Planning/follow up':
					sumPlanningOrFollowUp += downTimeInSeconds;
					if (downTimeInSeconds >= 900) {
						sumPlanningOrFollowUp15 += downTimeInSeconds;
					}
					break;
				case 'Administration, telephone':
					sumAdministrationTelephone += downTimeInSeconds;
					if (downTimeInSeconds >= 900) {
						sumAdministrationTelephone15 += downTimeInSeconds;
					}
					break;
				case 'Unproductive terrain work':
					sumUnproductiveTerrainWork += downTimeInSeconds;
					if (downTimeInSeconds >= 900) {
						sumUnproductiveTerrainWork15 += downTimeInSeconds;
					}
					break;
				case 'Trailer transportation':
					sumTrailerTransportation += downTimeInSeconds;
					if (downTimeInSeconds >= 900) {
						sumTrailerTransportation15 += downTimeInSeconds;
					}
					break;
			}
		}
		
		// OTHER WORK -> ROAD TRAVEL
		var ROAD_TRAVEL_SECONDS =  getMachineWorkTimeInSubCategory(payload, 'Other work', null, operatorKeyArray[operatorKeyIndex]);
		var ROAD_TRAVEL_HRS = Math.round((ROAD_TRAVEL_SECONDS / (60*60)) * 100 ) / 100;
		
		var hrs_sumRepair = Math.round((sumRepair / (60*60)) * 100 ) / 100;
		var hrs_sumRepair15 = Math.round((sumRepair15 / (60*60)) * 100 ) / 100;
		var hrs_sumMaintenance = Math.round((sumMaintenance / (60*60)) * 100 ) / 100;
		var hrs_sumMaintenance15 = Math.round((sumMaintenance15 / (60*60)) * 100 ) / 100;
		var hrs_sumDisturbance = Math.round((sumDisturbance / (60*60)) * 100 ) / 100;
		var hrs_sumDisturbance15 = Math.round((sumDisturbance15 / (60*60)) * 100 ) / 100;
		var hrs_sumOther = Math.round((sumOther / (60*60)) * 100 ) / 100;
		var hrs_sumOther15 = Math.round((sumOther15 / (60*60)) * 100 ) / 100;
	
		var hrs_sumWaitingForRepair = Math.round((sumWaitingForRepair / (60*60)) * 100 ) / 100;
		var hrs_sumWaitingForRepair15 = Math.round((sumWaitingForRepair15 / (60*60)) * 100 ) / 100;
		var hrs_sumPlanningOrFollowUp = Math.round((sumPlanningOrFollowUp / (60*60)) * 100 ) / 100;
		var hrs_sumPlanningOrFollowUp15 = Math.round((sumPlanningOrFollowUp15 / (60*60)) * 100 ) / 100;
		var hrs_sumAdministrationTelephone = Math.round((sumAdministrationTelephone / (60*60)) * 100 ) / 100;
		var hrs_sumAdministrationTelephone15 = Math.round((sumAdministrationTelephone15 / (60*60)) * 100 ) / 100;
		var hrs_sumUnproductiveTerrainWork = Math.round((sumUnproductiveTerrainWork / (60*60)) * 100 ) / 100;
		var hrs_sumUnproductiveTerrainWork15 = Math.round((sumUnproductiveTerrainWork15 / (60*60)) * 100 ) / 100;
		var hrs_sumTrailerTransportation = Math.round((sumTrailerTransportation / (60*60)) * 100 ) / 100;
		var hrs_sumTrailerTransportation15 = Math.round((sumTrailerTransportation15 / (60*60)) * 100 ) / 100;
		
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Repair total', hrs_sumRepair));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Maintenance total', hrs_sumMaintenance));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Disturbance total', hrs_sumDisturbance));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Other total', hrs_sumOther));
		
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Repair >15', hrs_sumRepair15));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Maintenance >15', hrs_sumMaintenance15));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Disturbance >15', hrs_sumDisturbance15));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Other >15', hrs_sumOther15));
		
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Waiting for repair total', hrs_sumWaitingForRepair));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Planning/Follow up total', hrs_sumPlanningOrFollowUp));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Administration, telephone total', hrs_sumAdministrationTelephone));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Unproductive terrain work total', hrs_sumUnproductiveTerrainWork));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Trailer transportation total', hrs_sumTrailerTransportation));
		
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Road travel total', ROAD_TRAVEL_HRS));
		
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Waiting for repair >15', hrs_sumWaitingForRepair15));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Planning/Follow up >15', hrs_sumPlanningOrFollowUp15));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Administration, telephone >15', hrs_sumAdministrationTelephone15));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Unproductive terrain work >15', hrs_sumUnproductiveTerrainWork15));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' Trailer transportation >15', hrs_sumTrailerTransportation15));
		
		sumRepair = 0;
		sumMaintenance = 0;
		sumDusturbance = 0;
		sumOther = 0;
		sumWaitingForRepair = 0;
		sumPlanningOrFollowUp = 0;
		sumAdministrationTelephone = 0;
		sumUnproductiveTerrainWork = 0;
		sumTrailerTransportation = 0;
		
		sumRepair15 = 0;
		sumMaintenance15 = 0;
		sumDusturbance15 = 0;
		sumOther15 = 0;
		sumWaitingForRepair15 = 0;
		sumPlanningOrFollowUp15 = 0;
		sumAdministrationTelephone15 = 0;
		sumUnproductiveTerrainWork15 = 0;
		sumTrailerTransportation15 = 0;
	}
	preview.push(tableBuilder('TABLE_BOTTOM', null, null));
	
	// PRODUCTION DATA
	preview.push(tableBuilder('TABLE_TOP', 'production', '<b>4. Production</b>'));
	preview.push(rowBuilder('<b>Volume</b>', '<b>m3</b>'));
	var sumOfVolumeOfStemsRecoded = [];
	for (var operatorKeyIndex in operatorKeyArray) {
		//HARVESTER ONLY
		//sumOfVolumeOfStemsRecoded = getSumOfVolumeOfStemsRecoded(payload, operatorKeyArray[operatorKeyIndex]);
		//for (var volumeIndex in sumOfVolumeOfStemsRecoded) {
		//	jsonObject = JSON.parse(sumOfVolumeOfStemsRecoded[volumeIndex]);
		//	preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' harvested volume ' + jsonObject.speciesGroupName, Math.round(jsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000));
		//}
		
		//m3sub
		sumOfVolumeOfStemsRecoded_volumeFiltered = getSumOfVolumeOfStemsRecoded_volumeFiltered(payload, operatorKeyArray[operatorKeyIndex], 'm3sub');
		var m3subTotal = 0;
		for (var volumeIndex in sumOfVolumeOfStemsRecoded_volumeFiltered) {
			jsonObject = JSON.parse(sumOfVolumeOfStemsRecoded_volumeFiltered[volumeIndex]);
			preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' harvested volume m3sub ' + jsonObject.speciesGroupName, Math.round(jsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000));
			m3subTotal += Math.round(jsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000;
		}
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' total harvested volume m3sub', m3subTotal));
		
		//m3sob
		sumOfVolumeOfStemsRecoded_volumeFiltered = getSumOfVolumeOfStemsRecoded_volumeFiltered(payload, operatorKeyArray[operatorKeyIndex], 'm3sob');
		var m3sobTotal = 0;
		for (var volumeIndex in sumOfVolumeOfStemsRecoded_volumeFiltered) {
			jsonObject = JSON.parse(sumOfVolumeOfStemsRecoded_volumeFiltered[volumeIndex]);
			preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' harvested volume m3sob ' + jsonObject.speciesGroupName, Math.round(jsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000));
			m3sobTotal += Math.round(jsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000;
		}
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' total harvested volume m3sob', m3sobTotal));
	}
	
	var sumOfForwardedVolumeInAndOut = [];
	for (var operatorKeyIndex in operatorKeyArray) {
		//FORWARDER ONLY
		sumOfForwardedVolumeInAndOut = getSumOfForwardedVolume(payload, operatorKeyArray[operatorKeyIndex]);
		jsonObject = JSON.parse(sumOfForwardedVolumeInAndOut);
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' forwarded volume m3sob', jsonObject.m3sob));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' forwarded volume m3sub', jsonObject.m3sub));
	}
	
	preview.push(rowBuilder('<b>Number of stems (Harvesters only)</b>', '<b>Pcs</b>'));
	var sumOfHarvestedStemsRecoded = [];
	var sumOfHarvestedStemsTotal = 0;
	for (var operatorKeyIndex in operatorKeyArray) {
		sumOfHarvestedStemsRecoded = getSumOfHarvestedStemsRecoded(payload, operatorKeyArray[operatorKeyIndex]);
		for (var stemCountIndex in sumOfHarvestedStemsRecoded) {
			jsonObject = JSON.parse(sumOfHarvestedStemsRecoded[stemCountIndex]);
			preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' number of cut ' + jsonObject.speciesGroupName, jsonObject.numberOfHarvestedStems));
			sumOfHarvestedStemsTotal += jsonObject.numberOfHarvestedStems;
		}
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' total number of cut stems', sumOfHarvestedStemsTotal));
		sumOfHarvestedStemsTotal = 0;
	}
	
	preview.push(tableBuilder('TABLE_BOTTOM', null, null)); 
	
	// FUEL DATA
	preview.push(tableBuilder('TABLE_TOP', 'fuel-consumption', '<b>5. Fuel consumption in litres</b>'));
	for (var operatorKeyIndex in operatorKeyArray) {
		if (OPERATIONAL_MONITORING_MACHINE_getWorkTimeObjectType(payload) === 'INDIVIDUAL') {
			preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' machine work time category','Individual'));
		}
		if (OPERATIONAL_MONITORING_MACHINE_getWorkTimeObjectType(payload) === 'COMBINED') {
			preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' machine work time category','Combined'));
			preview.push(rowBuilder('Remark','No machine work time category specific information on fuel consumption!'));
		}
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' processing', getSumOfFuelConsumption(payload, operatorKeyArray[operatorKeyIndex], 'Processing')));
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' total', getSumOfFuelConsumption(payload, operatorKeyArray[operatorKeyIndex], null)));
	}
	preview.push(tableBuilder('TABLE_BOTTOM', null, null));
	
	// ENGINE TIME
	preview.push(tableBuilder('TABLE_TOP', 'engine-time', '<b>6. Engine time in hours</b>'));
	for (var operatorKeyIndex in operatorKeyArray) {
		preview.push(rowBuilder('Operator ' + operatorKeyArray[operatorKeyIndex] + ' engine time', getSumOfEngineTime(payload, operatorKeyArray[operatorKeyIndex])));
	}
	preview.push(tableBuilder('TABLE_BOTTOM', null, null));
	
	// DOM REFRESH
	document.getElementById('data-inspector-placeholder').innerHTML += preview.join('');
	preview = [];
	
}

function exportpageSpinner(payloadArray) {

	location.href = '#export';
	
	document.getElementById('export-header').innerHTML = '';
	document.getElementById('export-content').innerHTML = '<div class="spinner">' +
														  '<div class="bounce1"></div>' +
										                  '<div class="bounce2"></div>' +
										                  '<div class="bounce3"></div>' +
									                      '</div><br><br>';
	
	var dummyLoop = setInterval(function() {
		clearInterval(dummyLoop);
		exportBuilder(payloadArray); // Function exportBuilder(array) is located in export.js
	}, 3000);

}

/*
 * Callback from exportBuilder() in export.js
 */
//function exportForm(headers, ex_separator, exportBlobFromExport, expFileName) {

function exportForm(exportFileName, exportObjectArray) {
	
	global_exportFileName = exportFileName;
	global_exportObjectArray = exportObjectArray;
	
	var exportBaseForm = [];
	
	exportBaseForm.push('<form>');
	
	// EXPRESS EXPORT BUTTON - DECIDED TO BE OBSOLETE
	//exportBaseForm.push('<section>');
	//exportBaseForm.push('<ul class="actions">');
	//exportBaseForm.push('<li><div class="button" id="express-export-file-button" onclick="executeExport()">Express Export</div></li>');
	//exportBaseForm.push('</ul>');
	//exportBaseForm.push('</section>');
	
	exportBaseForm.push('<section>');
	exportBaseForm.push('<div class="field">');
	exportBaseForm.push('<label for="file-name">Filename</label>');
	exportBaseForm.push('<input type="text" name="file-name" id="file-name" value="' + exportFileName + '" placeholder="" />');
	exportBaseForm.push('</div>');
	exportBaseForm.push('</section>');
	
	exportBaseForm.push('<section>');
	exportBaseForm.push('<label for="export-wide">Export file format</label>');
	//exportBaseForm.push('<div class="field" id="export-selection-top">');
	//exportBaseForm.push('<input type="radio" id="export-narrow" name="export-selection" onmouseover="" onmouseout="">');
	//exportBaseForm.push('<label for="export-narrow">Narrow</label>');
	//exportBaseForm.push('</div>');
	exportBaseForm.push('<div class="field">');
	exportBaseForm.push('<input type="radio" id="export-normal" name="export-selection" onmouseover="" onmouseout="" checked>');
	exportBaseForm.push('<label for="export-normal">Standard</label>');
	exportBaseForm.push('</div>');
	//exportBaseForm.push('<div class="field">');
	//exportBaseForm.push('<input type="radio" id="export-wide" name="export-selection" onmouseover="" onmouseout="">');
	//exportBaseForm.push('<label for="export-wide">Wide</label>');
	//exportBaseForm.push('</div>');
	exportBaseForm.push('</section>');
	
	exportBaseForm.push('<section>');
	exportBaseForm.push('<label for="column-separator-select">Column separator</label>'); 
	exportBaseForm.push('<div class="field half first" id="column-separator-select" onchange="columnSeparatorSelectOnChange()">');
	exportBaseForm.push('<div class="select-wrapper">');
	exportBaseForm.push('<select name="column-separator" id="column-separator">');
	exportBaseForm.push('<option value="semicolon">Semicolon</option>');
	exportBaseForm.push('<option value="tab">Tab</option>');
	exportBaseForm.push('<option value="other">Other</option>');
	exportBaseForm.push('</select>');
	exportBaseForm.push('</div>');
	exportBaseForm.push('</div>');
	exportBaseForm.push('<div class="field half">');
	exportBaseForm.push('<input type="text" name="other-separator" id="other-separator" value="" placeholder="" disabled />');
	exportBaseForm.push('</div>');
	exportBaseForm.push('</section>');
	
	/*
	exportBaseForm.push('<div class="field">');
	exportBaseForm.push('<input type="radio" id="export-all" name="export-all-selected" onclick="clearExportFieldsFromExportForm()" checked>');
	exportBaseForm.push('<label for="export-all">Export all fields</label>');
	exportBaseForm.push('</div>');
	exportBaseForm.push('<div class="field">');
	exportBaseForm.push('<input type="radio" id="export-selected" name="export-all-selected" onclick="getExportFields()">');
	exportBaseForm.push('<label for="export-selected">Export selected fields</label>');
	exportBaseForm.push('</div>');
	*/
	//exportBaseForm.push('<div id="export-fields"></div>');
	exportBaseForm.push('<section>');
	exportBaseForm.push('<ul class="actions">');
	//exportBaseForm.push('<li><div class="button" id="export-file-button" onclick="executeExport()">Export</div></li>');
	exportBaseForm.push('<li><div class="button" id="export-file-button" onclick="executeExport()">Export</div></li>');
	exportBaseForm.push('</ul>');
	exportBaseForm.push('</section>');
	//exportBaseForm.push('<section>');
	//exportBaseForm.push('<div class="field">');
	//exportBaseForm.push('<input type="checkbox" id="export-form-keep-active" name="export-form-keep-active" >');
	//exportBaseForm.push('<label for="export-form-keep-active">Stay on this page after export</label>');
	//exportBaseForm.push('</div>');
	//exportBaseForm.push('</section>');
	
	exportBaseForm.push('<section>');
	exportBaseForm.push('<hr>');
	exportBaseForm.push('<div id="export-form-notification-area"></div>');
	exportBaseForm.push('<hr>');
	exportBaseForm.push('</section>');
	exportBaseForm.push('<section>');
	exportBaseForm.push('<ul class="actions">');
	exportBaseForm.push('<li><a href="#content" class="button">Back to Inspector</a></li>');
	exportBaseForm.push('<li><a href="#" class="button">Back to Home</a></li>');
	exportBaseForm.push('</ul>');
	exportBaseForm.push('</section>');
	exportBaseForm.push('</form>');
	
	document.getElementById('export-header').innerHTML = '<h2 class="major" id="export-page-header">Export</h2>';
	document.getElementById('export-content').innerHTML = exportBaseForm.join('');
	
	//var columnCount = exportFileHeaders.split(separator).length;
	//set_notification_on_export_form('All fields selected (total ' + columnCount + ').');
	
}

function columnSeparatorSelectOnChange() {
	if (document.getElementById('column-separator').value === 'other') {
		document.getElementById('other-separator').disabled = false;
		document.getElementById('other-separator').focus();
	} else {
		document.getElementById('other-separator').value = '';
		document.getElementById('other-separator').disabled = true;
	}
}

function getSelectedSeparator() {

	var separator = ';'; //Semicolon as default
	
	switch(document.getElementById('column-separator').value) {
		case 'semicolon':
			separator = ';';
			break;
		case 'tab':
			separator = '\t';
			break;
		case 'other':
			if (document.getElementById('other-separator').value.trim() === '') {
				alert('Custom field separator is selected but the separator seems to be an empty string!');
				document.getElementById('other-separator').value = '';
				document.getElementById('other-separator').focus();
			} else {
				separator = document.getElementById('other-separator').value;
			}
			break;
		default:
			separator = ';';	
	}
	
	return separator;

}

function executeExport() {
	
	var fieldSeparator = getSelectedSeparator();
	
	// EXPORT FILE NAME
	var fileName = document.getElementById('file-name').value;
	if (fileName != global_exportFileName) {
		global_exportFileName = fileName;
	}
	//
	// EXPORT FILE FORMAT FUNTION CALL HERE
	//
	
	//Function call in export.js
	setFinalExport(global_exportFileName, global_exportObjectArray, null, fieldSeparator);
	
}

function deprecated_executeExport() {
	alert('executing export');
	var finalExportFieldIndicies = [];
	var exportAllRadioButton = document.getElementById('export-all');
	if (exportAllRadioButton.checked === true) {
		alert('select all checked');
		for (var i = 0; i < exportFileHeaders.split(separator).length; i++) { 
			finalExportFieldIndicies.push[i];
		}
	} else {
		finalExportFieldIndicies = selectedExportFieldIndices;
	}
	setFinalExport(finalExportFieldIndicies, exportFile, exportFileHeaders, exportFileName);
}

function clearExportFieldsFromExportForm() {
	document.getElementById('export-fields').innerHTML = '';
	document.getElementById('timeline-button-placeholder').innerHTML = '';
	var exportFileButtonObject = document.getElementById('export-file-button');
	exportFileButtonObject.setAttribute('class','button');
	set_notification_on_export_form('All fields selected (total ' + exportFileHeaders.split(separator).length + ').');
}

function exportFieldsToggleOnChange(controlObject) {
	var exportFileHeaderTokens = [];
	exportFileHeaderTokens = exportFileHeaders.split(separator);
	var exportFieldObject;
	for (var exportHeaderIndex in exportFileHeaderTokens) {
		exportFieldObject = document.getElementById('export-field-' + exportHeaderIndex);
		if (controlObject.checked) {
			if (!exportFieldObject.checked) {
				exportFieldObject.checked = true;
			}
		} else {
			if (exportFieldObject.checked) {
				exportFieldObject.checked = false;
			}
		}
		
	}
	updateSelectedExportFieldIndices(null);
}

function updateSelectedExportFieldIndices(controlObject) {
	selectedExportFieldIndices = [];
	var exportFileHeaderTokens = [];
	exportFileHeaderTokens = exportFileHeaders.split(separator);
	var exportFieldObject;
	for (var exportHeaderIndex in exportFileHeaderTokens) {
		exportFieldObject = document.getElementById('export-field-' + exportHeaderIndex);
		if (exportFieldObject.checked) {
			selectedExportFieldIndices.push(exportHeaderIndex);
		}
	}
	
	var exportFileButtonObject = document.getElementById('export-file-button');
	if (selectedExportFieldIndices.length === 0) {
		exportFileButtonObject.setAttribute('class','button disabled');
	} else {
		exportFileButtonObject.setAttribute('class','button');
	}
	
	//for (var exportFieldIndex in selectedExportFieldIndices) {
	//	console.log(selectedExportFieldIndices[exportFieldIndex]);
	//}
	
	//EXPORT FORM NOTIFICATION
	var messageString = '';
	if (selectedExportFieldIndices.length === 0) {
		messageString = 'No fields selected.';
	} else if (selectedExportFieldIndices.length === 1) {
		messageString = 'One field selected.';
	} else {
		messageString = selectedExportFieldIndices.length + ' fields selected.'
	}
	if (selectedExportFieldIndices.length === exportFileHeaderTokens.length) {
		messageString = 'All fields selected (total ' + exportFileHeaderTokens.length + ').';
	}
	set_notification_on_export_form(messageString);
}

function checkRefresh() {
	window.addEventListener('load', function(e) {
	//HTML5 APP CACHE CONTROL
	window.applicationCache.addEventListener('updateready', function(e) {
		if (window.applicationCache.status == window.applicationCache.UPDATEREADY) {
			// Browser downloaded a new app cache.
			// Swap it in and reload the page to get the new hotness.
			window.applicationCache.swapCache();
			if (confirm('A new version of this site is available. Load it?')) {
				window.location.reload();
			}
			} else {
			// Manifest didn't changed. Nothing new to server.
			}
		}, false);

	}, false);
	//REDIRECT TO CONETENT
	location.href = '#header';
}

function getExportFields() {
	
	var exportFormHeaderSelect = [];
	var exportFileHeaderTokens = [];
	var headerFieldOriginal;
	var headerFieldViewstring;
	var headerFieldID;
	var checkedString = '';
	exportFileHeaderTokens = exportFileHeaders.split(separator);
	if (exportFileHeaderTokens.length === selectedExportFieldIndices.length) {
		checkedString = 'checked';
	}
	exportFormHeaderSelect.push('<div class="field">');
	exportFormHeaderSelect.push('<input type="checkbox" id="export-field-select-toggle" name="export-field-select-toggle" onchange="exportFieldsToggleOnChange(this)" ' + checkedString + '>');
	exportFormHeaderSelect.push('<label for="export-field-select-toggle">SELECT/DESELECT ALL</label>');
	exportFormHeaderSelect.push('</div>');
	//exportFormHeaderSelect.push('<hr />');
	for (var exportHeaderIndex in exportFileHeaderTokens) {
		checkedString = '';
		if (selectedExportFieldIndices.indexOf(exportHeaderIndex) != -1) {
			checkedString = 'checked';
		}
		headerFieldOriginal = exportFileHeaderTokens[exportHeaderIndex];
		headerFieldViewstring = headerFieldOriginal.toUpperCase();
		headerFielID = exportHeaderIndex;
		//WHITE-SPACE-REMOVE-STRING: .replace(/\s/g,'')
		exportFormHeaderSelect.push('<div class="field">');
		exportFormHeaderSelect.push('<input type="checkbox" id="export-field-' + headerFielID + '" name="export-field-' + headerFielID + '" onchange="updateSelectedExportFieldIndices(this)" ' + checkedString + '>');
		exportFormHeaderSelect.push('<label for="export-field-' + headerFielID + '">' + headerFieldViewstring + '</label>');
		exportFormHeaderSelect.push('</div>');
	}
	
	document.getElementById('export-fields').innerHTML = exportFormHeaderSelect.join('');
	updateSelectedExportFieldIndices(null);
}

function tableBuilder(section, tableId, tableHeader) {

	var tableTop = '<label for="' + tableId + '">' + tableHeader + '</label>' +
				   '<div class="table-wrapper" name="' + tableId + '">' +
				   '<table>' +
				   '<thead>' +
				   '<tr>' +
				   '<th>Key</th>' +
				   '<th>Value</th>' +
				   '</tr>' +
				   '</thead>' +
				   '<tbody>';
	
	var tableBottom = '</tbody>' +
					  '</table>' +
				      '</div>';
	
	if (section === 'TABLE_TOP') {
		return tableTop;
	} else if (section === 'TABLE_BOTTOM') {
		return tableBottom;
	} else {
		return '';
	}

}

function rowBuilder(key, value) {

	var row = '<tr>' +
			  '<td>' + key + '</td>' +
			  '<td>' + value + '</td>' +
			  '</tr>';
	
	return row;

}
