
function log(message) {
	console.log(message);
}

function exportBuilder(payloadArray) { 

	console.clear();
	
	var jsonObject;
	var payload;
	
	var exportFileFieldSeparator;
	var exportFileFilename;
	
	var exportDataRowsArray = [];
	
	var operatorKeyArray;
	
	var dataRow = 1;
	
	var trimVar;
	
	for (var momDocument in payloadArray) {
		console.log((parseInt(momDocument) + 1) + '/' + payloadArray.length);
		payload = payloadArray[momDocument];
		console.log('Payload');
		console.log(payload);
		jsonObject = JSON.parse(payload);
		//OPERATOR KEYS
		operatorKeyArray = OPERATIONAL_MONITORING_MACHINE_getOperatorKeys(payload);
		for (var operatorKeyIndex in operatorKeyArray) {
			
			//DATA ROW
			dataStructure = getDataStructure();
			dataStructure['"Data_row"'] = dataRow;
			dataRow++;
			
			//FILE NAME
			trimVar = jsonObject.filename;
			trimVar = trimVar.trim();
			dataStructure['"File_name"'] = trimVar;
			
			// MACHINE ID
			trimVar = OPERATIONAL_MONITORING_MACHINE_getValue(payload, 'MachineKey');
			trimVar = trimVar.trim();
			dataStructure['"Machine_ID"'] = trimVar;
			
			// MACHINE BASE MANUFACTURER
			trimVar = OPERATIONAL_MONITORING_MACHINE_getValue(payload, 'MachineBaseManufacturer');
			trimVar = trimVar.trim();
			dataStructure['"Machine_manufacturer"'] = trimVar;
			
			// MACHINE CATEGORY
			trimVar = OPERATIONAL_MONITORING_MACHINE_CATEGORY_getValue(payload);
			var machineCategory = trimVar.trim();
			dataStructure['"Machine_category"'] = machineCategory;
			machineCategory = machineCategory.toUpperCase();
			
			// SITE ID
			
			// START TIME ON SITE
			trimVar = getMachineWorkTimeStartTime(payload);
			trimVar = trimVar.trim();
			dataStructure['"Start_time"'] = trimVar;
			
			// END TIME ON SITE
			trimVar = getMachineWorkTimeEndTime(payload);
			trimVar = trimVar.trim();
			dataStructure['"End_time"'] = trimVar;
			
			// CUSTOMER
			trimVar = OPERATIONAL_MONITORING_MACHINE_OBJECT_DEFINITION_getLoggingOrganisation(payload);
			console.log(trimVar); 
			if (trimVar) {
				trimVar = trimVar.trim();
			}
			dataStructure['"Customer"'] = trimVar;
			//console.log(OPERATIONAL_MONITORING_MACHINE_OBJECT_DEFINITION_getLoggingOrganisation(payload));
			
			// LOGGING FORM
			var loggingForm = OPERATIONAL_MONITORING_MACHINE_OBJECT_DEFINITION_getLoggingForm(payload);
			var loggingFormCode = '';
			var loggingFormDescription = '';
			if (loggingForm) {
				loggingFormCode = loggingForm.LoggingFormCode;
				loggingFormCode = loggingFormCode.trim();
				loggingFormDescription = loggingForm.LoggingFormDescription;
				loggingFormDescription = loggingFormDescription.trim();
			}
			dataStructure['"Felling_class"'] = loggingFormCode + ' ' + loggingFormDescription;
			
			// OPERATOR ID
			var operatorFirstName = getOperatorName(payload, operatorKeyArray[operatorKeyIndex]);
			if (operatorFirstName !== 'NaN') {
				dataStructure['"Operator_ID"'] = operatorKeyArray[operatorKeyIndex] + '_' + operatorFirstName;
				//console.log(operatorKeyArray[operatorKeyIndex] + '_' + operatorFirstName);
			} else {
				dataStructure['"Operator_ID"'] = operatorKeyArray[operatorKeyIndex];
				//console.log(operatorKeyArray[operatorKeyIndex]);
			}
			
			// DRIVEN DISTANCE
			var drivenDistance = 0;
			var forwarderLoads = 0;
			var forwarderDrivenDistance = 0;
			var meanForwarderDistance = 0;
			if (machineCategory === 'FORWARDER') {
				//console.log('Machine category is forwarder');
				if(getSumOfForwarderLoadCount(payload, operatorKeyArray[operatorKeyIndex]) > 0) {
					forwarderLoadCount = getSumOfForwarderLoadCount(payload, operatorKeyArray[operatorKeyIndex]);
					forwarderLoads = forwarderLoadCount;
					sumOfDrivenDistance = getSumOfDrivenDistance(payload, operatorKeyArray[operatorKeyIndex]);
					forwarderDrivenDistance = sumOfDrivenDistance;
					meanForwarderDistance = (sumOfDrivenDistance/forwarderLoadCount)/2;
				} else {
					forwarderLoadCount = getSumOfForwarderLoadCount(payload, operatorKeyArray[operatorKeyIndex]);
					forwarderLoads = forwarderLoadCount;
					sumOfDrivenDistance = getSumOfDrivenDistance(payload, operatorKeyArray[operatorKeyIndex]);
					forwarderDrivenDistance = sumOfDrivenDistance;
				}
				drivenDistance = forwarderDrivenDistance;
			}
			if (machineCategory === 'HARVESTER') {
				sumOfDrivenDistance = getSumOfDrivenDistance(payload, operatorKeyArray[operatorKeyIndex]);
				drivenDistance = sumOfDrivenDistance;
			}
			dataStructure['"Driven_total_distance"'] = Math.round( (drivenDistance) * 100 ) / 100;
			dataStructure['"Mean_Forwarding_distance"'] = Math.round( (meanForwarderDistance) * 100 ) / 100;
			dataStructure['"Forwarder_loads"'] = forwarderLoads;
	
			// FILTER TIME DOWN
			// FILTER TIME RUN
			// FILTER TIME MINIMUM
			var monitoringSettingsObject = OPERATIONAL_MONITORING_MACHINE_getMonitoringSettings(payload); 
			if (OPERATIONAL_MONITORING_MACHINE_getMonitoringSettingsReturnType(payload) === 'Object') {
				dataStructure['"Filter_time_down"'] = OPERATIONAL_MONITORING_MACHINE_MONITORING_SETTINGS_getMonitoringFilterTimeDown(monitoringSettingsObject);
				dataStructure['"Filter_time_run"'] = OPERATIONAL_MONITORING_MACHINE_MONITORING_SETTINGS_getMonitoringFilterTimeRun(monitoringSettingsObject);
				dataStructure['"Filter_time_minimum"'] = OPERATIONAL_MONITORING_MACHINE_MONITORING_SETTINGS_getMonitoringFilterTimeMinimum(monitoringSettingsObject);
			}
			if (OPERATIONAL_MONITORING_MACHINE_getMonitoringSettingsReturnType(payload) === 'Array') {
				dataStructure['"Filter_time_down"'] = OPERATIONAL_MONITORING_MACHINE_MONITORING_SETTINGS_getMonitoringFilterTimeDown(monitoringSettingsObject[0]);
				dataStructure['"Filter_time_run"'] = OPERATIONAL_MONITORING_MACHINE_MONITORING_SETTINGS_getMonitoringFilterTimeRun(monitoringSettingsObject[0]);
				dataStructure['"Filter_time_min"'] = OPERATIONAL_MONITORING_MACHINE_MONITORING_SETTINGS_getMonitoringFilterTimeMinimum(monitoringSettingsObject[0]);
			}

			//RECORDED TIME DATA:
			
			var operatorWorkTime = 0;
			
			// OPERATOR MACHINE WORK
			dataStructure['"Operator_Machine_work"'] = getSecondsInHours(getOperatorWorkTimeInCategory(payload, 'MachineWorkTime', operatorKeyArray[operatorKeyIndex]));
			operatorWorkTime += getSecondsInHours(getOperatorWorkTimeInCategory(payload, 'MachineWorkTime', operatorKeyArray[operatorKeyIndex]));
			
			// OPERATOR MEAL BREAK
			dataStructure['"Operator_Meal_break"'] = getSecondsInHours(getOperatorWorkTimeInCategory(payload, 'Meal break', operatorKeyArray[operatorKeyIndex]));
			operatorWorkTime += getSecondsInHours(getOperatorWorkTimeInCategory(payload, 'Meal break', operatorKeyArray[operatorKeyIndex]));
			
			// OPERATOR PLANNING AND OTHER WORK OUTSIDE MACHINE (SUM FIELD)
			var planningTime = 0;
			planningTime = getOperatorWorkTimeInCategory(payload, 'Planning outside machine', operatorKeyArray[operatorKeyIndex]);
			planningTime += getOperatorWorkTimeInCategory(payload, 'Other work outside machine', operatorKeyArray[operatorKeyIndex]);
			dataStructure['"Operator_Planning_and_other"'] = getSecondsInHours(planningTime);
			operatorWorkTime += getSecondsInHours(planningTime);
			
			// OPERATOR TRAVELLING TO WORK OUTSIDE MACHINE
			dataStructure['"Operator_Travelling_to_work_outside_machine"'] = getSecondsInHours(getOperatorWorkTimeInCategory(payload, 'Travelling to work outside machine', operatorKeyArray[operatorKeyIndex]));
			operatorWorkTime += getSecondsInHours(getOperatorWorkTimeInCategory(payload, 'Travelling to work outside machine', operatorKeyArray[operatorKeyIndex]));
			
			
			// MACHINE PROCESSING
			var machineProcessing = getSecondsInHours(getMachineWorkTimeInCategory(payload, 'Processing', operatorKeyArray[operatorKeyIndex]));
			dataStructure['"Machine_Processing"'] = machineProcessing;
			
			// MACHINE TERRAIN TRAVEL
			var machineTerrainTravel = getSecondsInHours(getMachineWorkTimeInCategory(payload, 'Terrain travel', operatorKeyArray[operatorKeyIndex]));
			dataStructure['"Machine_Terrain_travel"'] = machineTerrainTravel;
			
			// MACHINE TERRAIN TRAVEL (<15)
			var machineTerrainTravel_15 = getSecondsInHours(getFilteredMachineWorkTimeInCategory(payload, 'Terrain travel', operatorKeyArray[operatorKeyIndex], 900));
			dataStructure['"Machine_Terrain_travel (<15)"'] = machineTerrainTravel_15;
			
			// MACHINE OTHER WORK
			var machineOtherWork = getSecondsInHours(getMachineWorkTimeInCategory(payload, 'Other work', operatorKeyArray[operatorKeyIndex]));
			dataStructure['"Machine_Other_work"'] = machineOtherWork;
			
			// MACHINE OTHER WORK (<15)
			var machineOtherWork_15 = getSecondsInHours(getFilteredMachineWorkTimeInCategory(payload, 'Other work', operatorKeyArray[operatorKeyIndex], 900));
			dataStructure['"Machine_Other_work (<15)"'] = machineOtherWork_15;
			
			// MACHINE DOWN TIME
			var machineDownTime = getSecondsInHours(getMachineDownTime(payload, operatorKeyArray[operatorKeyIndex]));
			dataStructure['"Machine_Down_time"'] = machineDownTime;
			
			// MACHINE DOWN TIME (<15)
			var machineDownTime_15 = getSecondsInHours(getFilteredMachineDownTime(payload, operatorKeyArray[operatorKeyIndex], 900));
			dataStructure['"Machine_Down_time (<15)"'] = machineDownTime_15;
			
			dataStructure['"Harvester_Utilised_time"'] = 0;
			dataStructure['"Harvester_E15_time"'] = 0;
			dataStructure['"Harvester_E0_productive_time"'] = 0;
			dataStructure['"Forwarder_Utilised_time"'] = 0;
			dataStructure['"Forwarder_E15_time"'] = 0;
			dataStructure['"Forwarder_E0_productive_time"'] = 0;
			
			var machineUtilizedTime = 0;
			var machineEffectiveTime = 0;
			
			if (machineCategory === 'HARVESTER') {
			
				// HARVESTER UTILISED TIME
				// MachineRunTime (processing + terrain travel + other work) + MachineDownTime
				dataStructure['"Harvester_Utilised_time"'] = Math.round( (machineProcessing + machineTerrainTravel + machineOtherWork + machineDownTime) * 100 ) / 100;
				machineUtilizedTime = Math.round( (machineProcessing + machineTerrainTravel + machineOtherWork + machineDownTime) * 100 ) / 100;
			
				// HARVESTER EFFECTIVE WORK TIME
				// Processing+(MachineDownTime<15 min)+(TerrainTravel<15 min)+(OtherWork<15min)
				dataStructure['"Harvester_E15_time"'] = Math.round( (machineProcessing + machineDownTime_15 + machineTerrainTravel_15 + machineOtherWork_15) * 100 ) / 100;
				machineEffectiveTime = Math.round( (machineProcessing + machineDownTime_15 + machineTerrainTravel_15 + machineOtherWork_15) * 100 ) / 100;
			
				// HARVESTER PRODUCTIVE WORK TIME 
				// Same as Processing
				dataStructure['"Harvester_E0_productive_time"'] = machineProcessing;
			
			}
			
			if (machineCategory === 'FORWARDER') {
			
				// FORWARDER UTILISED TIME
				// MachineRunTime (processing + terrain travel + other work) + MachineDownTime
				dataStructure['"Forwarder_Utilised_time"'] = Math.round( (machineProcessing + machineTerrainTravel + machineOtherWork + machineDownTime) * 100 ) / 100;
				machineUtilizedTime = Math.round( (machineProcessing + machineTerrainTravel + machineOtherWork + machineDownTime) * 100 ) / 100;
			
				// FORWARDER EFFECTIVE WORK TIME
				// Processing+(MachineDownTime<15 min)+(TerrainTravel<15 min)+(OtherWork<15min)
				dataStructure['"Forwarder_E15_time"'] = Math.round( (machineProcessing + machineDownTime_15 + machineTerrainTravel_15 + machineOtherWork_15) * 100 ) / 100;
				machineEffectiveTime = Math.round( (machineProcessing + machineDownTime_15 + machineTerrainTravel_15 + machineOtherWork_15) * 100 ) / 100;
			
				// FORWARDER PRODUCTIVE WORK TIME 
				dataStructure['"Forwarder_E0_productive_time"'] = machineProcessing + machineTerrainTravel;
			
			}
			
			// DOWN TIME CATEGORIES
			var downTimeCategory;
			var downTimeStandardCode;
			var downTimeInSeconds;
			var downTimeObjects;
			var downTimeJSON;
			
			var sumRepair = 0;
			var sumRepair15 = 0;
			var sumMaintenance = 0;
			var sumMaintenance15 = 0;
			var sumDisturbance = 0;
			var sumDisturbance15 = 0;
			var sumOther = 0;
			var sumOther15 = 0;
	
			var sumWaitingForRepair = 0;
			var sumWaitingForRepair15 = 0;
			var sumPlanningOrFollowUp = 0;
			var sumPlanningOrFollowUp15 = 0;
			var sumAdministrationTelephone = 0;
			var sumAdministrationTelephone15 = 0;
			var sumUnproductiveTerrainWork = 0;
			var sumUnproductiveTerrainWork15 = 0;
			var sumTrailerTransportation = 0;
			var sumTrailerTransportation15 = 0;

			var sumRoadTravel = getMachineWorkTimeInSubCategory(payload, 'Other work', null, operatorKeyArray[operatorKeyIndex]);
			var hrs_sumRoadTravel = Math.round((sumRoadTravel / (60*60)) * 100 ) / 100;
			
			downTimeObjects = getDownTimeArray(payload, operatorKeyArray[operatorKeyIndex]);
			for (var downTimeIndex in downTimeObjects) {
				downTimeObject = downTimeObjects[downTimeIndex];
				downTimeJSON = JSON.parse(downTimeObject);
				downTimeCategory = downTimeJSON.downTimeCategory;
				downTimeStandardCode = downTimeJSON.downTimeStandardCode;
				downTimeInSeconds = downTimeJSON.downTimeInSeconds;
				switch(downTimeCategory) {
					case 'Repair':
						sumRepair += downTimeInSeconds;
						if (downTimeInSeconds >= 900) {
							sumRepair15 += downTimeInSeconds;
						}
						break;
					case 'Maintenance':
						sumMaintenance += downTimeInSeconds;
						if (downTimeInSeconds >= 900) {
							sumMaintenance15 += downTimeInSeconds;
						}
						break;
					case 'Disturbance':
						sumDisturbance += downTimeInSeconds;
						if (downTimeInSeconds >= 900) {
							sumDisturbance15 += downTimeInSeconds;
						}
						break;
					case 'Other':
						sumOther += downTimeInSeconds;
						if (downTimeInSeconds >= 900) {
							sumOther15 += downTimeInSeconds;
						}
						break;
				}	
			
				switch (downTimeStandardCode) {
					case 'Waiting for repair':
						sumWaitingForRepair += downTimeInSeconds;
						if (downTimeInSeconds >= 900) {
							sumWaitingForRepair15 += downTimeInSeconds;
						}
						break;
					case 'Planning/follow up':
						sumPlanningOrFollowUp += downTimeInSeconds;
						if (downTimeInSeconds >= 900) {
							sumPlanningOrFollowUp15 += downTimeInSeconds;
						}
						break;
					case 'Administration, telephone':
						sumAdministrationTelephone += downTimeInSeconds;
						if (downTimeInSeconds >= 900) {
							sumAdministrationTelephone15 += downTimeInSeconds;
						}
						break;
					case 'Unproductive terrain work':
						sumUnproductiveTerrainWork += downTimeInSeconds;
						if (downTimeInSeconds >= 900) {
							sumUnproductiveTerrainWork15 += downTimeInSeconds;
						}
						break;
					case 'Trailer transportation':
						sumTrailerTransportation += downTimeInSeconds;
						if (downTimeInSeconds >= 900) {
							sumTrailerTransportation15 += downTimeInSeconds;
						}
						break;
				}
			}
		
			var hrs_sumRepair = Math.round((sumRepair / (60*60)) * 100 ) / 100;
			var hrs_sumRepair15 = Math.round((sumRepair15 / (60*60)) * 100 ) / 100;
			var hrs_sumMaintenance = Math.round((sumMaintenance / (60*60)) * 100 ) / 100;
			var hrs_sumMaintenance15 = Math.round((sumMaintenance15 / (60*60)) * 100 ) / 100;
			var hrs_sumDisturbance = Math.round((sumDisturbance / (60*60)) * 100 ) / 100;
			var hrs_sumDisturbance15 = Math.round((sumDisturbance15 / (60*60)) * 100 ) / 100;
			var hrs_sumOther = Math.round((sumOther / (60*60)) * 100 ) / 100;
			var hrs_sumOther15 = Math.round((sumOther15 / (60*60)) * 100 ) / 100;
	
			var hrs_sumWaitingForRepair = Math.round((sumWaitingForRepair / (60*60)) * 100 ) / 100;
			var hrs_sumWaitingForRepair15 = Math.round((sumWaitingForRepair15 / (60*60)) * 100 ) / 100;
			var hrs_sumPlanningOrFollowUp = Math.round((sumPlanningOrFollowUp / (60*60)) * 100 ) / 100;
			var hrs_sumPlanningOrFollowUp15 = Math.round((sumPlanningOrFollowUp15 / (60*60)) * 100 ) / 100;
			var hrs_sumAdministrationTelephone = Math.round((sumAdministrationTelephone / (60*60)) * 100 ) / 100;
			var hrs_sumAdministrationTelephone15 = Math.round((sumAdministrationTelephone15 / (60*60)) * 100 ) / 100;
			var hrs_sumUnproductiveTerrainWork = Math.round((sumUnproductiveTerrainWork / (60*60)) * 100 ) / 100;
			var hrs_sumUnproductiveTerrainWork15 = Math.round((sumUnproductiveTerrainWork15 / (60*60)) * 100 ) / 100;
			var hrs_sumTrailerTransportation = Math.round((sumTrailerTransportation / (60*60)) * 100 ) / 100;
			var hrs_sumTrailerTransportation15 = Math.round((sumTrailerTransportation15 / (60*60)) * 100 ) / 100;
			
			dataStructure['"Repair"'] = hrs_sumRepair;
			dataStructure['"Repair (>15 min)"'] = hrs_sumRepair15;
			dataStructure['"Maintenance"'] = hrs_sumMaintenance;
			dataStructure['"Maintenance (>15 min)"'] = hrs_sumMaintenance15;
			dataStructure['"Disturbance"'] = hrs_sumDisturbance;
			dataStructure['"Disturbance (>15 min)"'] = hrs_sumDisturbance15;
			dataStructure['"Other_down_time"'] = hrs_sumOther;
			dataStructure['"Other_down_time (>15 min)"'] = hrs_sumOther15;
			dataStructure['"Waiting_for_repair"'] = hrs_sumWaitingForRepair;
			dataStructure['"Waiting_for_repair (>15 min)"'] = hrs_sumWaitingForRepair;
			dataStructure['"Planning_or_follow_up"'] = hrs_sumPlanningOrFollowUp;
			dataStructure['"Planning_or_follow_up (>15 min)"'] = hrs_sumPlanningOrFollowUp15;
			dataStructure['"Administration_telephone"'] = hrs_sumAdministrationTelephone;
			dataStructure['"Administration_telephone (>15 min)"'] = hrs_sumAdministrationTelephone15;
			dataStructure['"Unproductive_terrain_work"'] = hrs_sumUnproductiveTerrainWork;
			dataStructure['"Unproductive_terrain_work (>15 min)"'] = hrs_sumUnproductiveTerrainWork15;
			dataStructure['"Trailer_transportation"'] = hrs_sumTrailerTransportation;
			dataStructure['"Trailer_transportation (>15 min)"'] = hrs_sumTrailerTransportation15;
		
			dataStructure['"Planning_follow_up_administration (>15)"'] = hrs_sumPlanningOrFollowUp15 + hrs_sumAdministrationTelephone15;
			dataStructure['"Other disturbance (>15)"'] = hrs_sumDisturbance15 - hrs_sumPlanningOrFollowUp15 - hrs_sumAdministrationTelephone15;
		
			dataStructure['"Road travel"'] = hrs_sumRoadTravel;
			sumRoadTravel = 0;
			
			sumRepair = 0;
			sumMaintenance = 0;
			sumDusturbance = 0;
			sumOther = 0;
			sumWaitingForRepair = 0;
			sumPlanningOrFollowUp = 0;
			sumAdministrationTelephone = 0;
			sumUnproductiveTerrainWork = 0;
			sumTrailerTransportation = 0;
		
			sumRepair15 = 0;
			sumMaintenance15 = 0;
			sumDusturbance15 = 0;
			sumOther15 = 0;
			sumWaitingForRepair15 = 0;
			sumPlanningOrFollowUp15 = 0;
			sumAdministrationTelephone15 = 0;
			sumUnproductiveTerrainWork15 = 0;
			sumTrailerTransportation15 = 0;
			
			// VOLUME
			// HARVESTED VOLUME
			var volumeJsonObject;
			// M3SUB
			sumOfVolumeOfStemsRecoded_volumeFiltered = getSumOfVolumeOfStemsRecoded_volumeFiltered(payload, operatorKeyArray[operatorKeyIndex], 'm3sub');
			var m3subTotal = 0;
			for (var volumeIndex in sumOfVolumeOfStemsRecoded_volumeFiltered) {
				volumeJsonObject = JSON.parse(sumOfVolumeOfStemsRecoded_volumeFiltered[volumeIndex]);
				if (volumeJsonObject.speciesGroupName === 'Pine') {
					dataStructure['"Harvested_volume_Pine_m3sub"'] = Math.round(volumeJsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000;
					m3subTotal += Math.round(volumeJsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000;
				}
				if (volumeJsonObject.speciesGroupName === 'Spruce') {
					dataStructure['"Harvested_volume_Spruce_m3sub"'] = Math.round(volumeJsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000;
					m3subTotal += Math.round(volumeJsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000;
				}
				if (volumeJsonObject.speciesGroupName === 'Birch') {
					dataStructure['"Harvested_volume_Birch_m3sub"'] = Math.round(volumeJsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000;
					m3subTotal += Math.round(volumeJsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000;
				}
				if (volumeJsonObject.speciesGroupName === 'Other') {
					dataStructure['"Harvested_volume_Other_m3sub"'] = Math.round(volumeJsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000;
					m3subTotal += Math.round(volumeJsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000;
				}
			}
			dataStructure['"Harvested_volume_Total_m3sub"'] = m3subTotal;
			// M3SUB
			sumOfVolumeOfStemsRecoded_volumeFiltered = getSumOfVolumeOfStemsRecoded_volumeFiltered(payload, operatorKeyArray[operatorKeyIndex], 'm3sob');
			var m3sobTotal = 0;
			for (var volumeIndex in sumOfVolumeOfStemsRecoded_volumeFiltered) {
				volumeJsonObject = JSON.parse(sumOfVolumeOfStemsRecoded_volumeFiltered[volumeIndex]);
				if (volumeJsonObject.speciesGroupName === 'Pine') {
					dataStructure['"Harvested_volume_Pine_m3sob"'] = Math.round(volumeJsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000;
					m3sobTotal += Math.round(volumeJsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000;
				}
				if (volumeJsonObject.speciesGroupName === 'Spruce') {
					dataStructure['"Harvested_volume_Spruce_m3sob"'] = Math.round(volumeJsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000;
					m3sobTotal += Math.round(volumeJsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000;
				}
				if (volumeJsonObject.speciesGroupName === 'Birch') {
					dataStructure['"Harvested_volume_Birch_m3sob"'] = Math.round(volumeJsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000;
					m3sobTotal += Math.round(volumeJsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000;
				}
				if (volumeJsonObject.speciesGroupName === 'Other') {
					dataStructure['"Harvested_volume_Other_m3sob"'] = Math.round(volumeJsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000;
					m3sobTotal += Math.round(volumeJsonObject.sumOfVolumeOfHarvestedStems * 1000) / 1000;
				}
			}
			dataStructure['"Harvested_volume_Total_m3sob"'] = m3sobTotal;
			
			// FORWARDED VOLUME
			var sumOfForwardedVolumeInAndOut = getSumOfForwardedVolume(payload, operatorKeyArray[operatorKeyIndex]);
			volumeJsonObject = JSON.parse(sumOfForwardedVolumeInAndOut);
			dataStructure['"Forwarded_volume_m3sob"'] = Math.round(volumeJsonObject.m3sob * 1000) / 1000;
			dataStructure['"Forwarded_volume_m3sub"'] = Math.round(volumeJsonObject.m3sub * 1000) / 1000;
			
			//NUMBER OF STEMS (HARVESTER ONLY)
			var sumOfHarvestedStemsRecoded = getSumOfHarvestedStemsRecoded(payload, operatorKeyArray[operatorKeyIndex]);
			var stemCountJsonObject;
			var sumOfHarvestedStemsTotal = 0;
			for (var stemCountIndex in sumOfHarvestedStemsRecoded) {
				stemCountJsonObject = JSON.parse(sumOfHarvestedStemsRecoded[stemCountIndex]);
				if (stemCountJsonObject.speciesGroupName === 'Pine') {
					dataStructure['"Number_of_pine"'] = stemCountJsonObject.numberOfHarvestedStems;
					sumOfHarvestedStemsTotal += stemCountJsonObject.numberOfHarvestedStems;
				}
				if (stemCountJsonObject.speciesGroupName === 'Spruce') {
					dataStructure['"Number_of_spruce"'] = stemCountJsonObject.numberOfHarvestedStems;
					sumOfHarvestedStemsTotal += stemCountJsonObject.numberOfHarvestedStems;
				}
				if (stemCountJsonObject.speciesGroupName === 'Birch') {
					dataStructure['"Number_of_birch"'] = stemCountJsonObject.numberOfHarvestedStems;
					sumOfHarvestedStemsTotal += stemCountJsonObject.numberOfHarvestedStems;
				}
				if (stemCountJsonObject.speciesGroupName === 'Other') {
					dataStructure['"Number_of_other"'] = stemCountJsonObject.numberOfHarvestedStems;
					sumOfHarvestedStemsTotal += stemCountJsonObject.numberOfHarvestedStems;
				}
			}
			dataStructure['"Number_of_all"'] = sumOfHarvestedStemsTotal;
			
			// AVERAGE VOLUME DM3
			if (sumOfHarvestedStemsTotal === 0) {
				dataStructure['"dm3sob"'] = 0;
				dataStructure['"dm3sub"'] = 0;
			} else {
				dataStructure['"dm3sob"'] = Math.round((1000 * m3sobTotal / sumOfHarvestedStemsTotal) * 1000) / 1000;
				dataStructure['"dm3sub"'] = Math.round((1000 * m3subTotal / sumOfHarvestedStemsTotal) * 1000) / 1000;
			}
			// PRODUCTIVITY
			if (operatorWorkTime === 0) {
				dataStructure['"Productivity_work_time_sob"'] = 0;
				dataStructure['"Productivity_work_time_sub"'] = 0;
			} else {
				dataStructure['"Productivity_work_time_sob"'] = Math.round((m3sobTotal / operatorWorkTime) * 1000) / 1000;
				dataStructure['"Productivity_work_time_sub"'] = Math.round((m3subTotal / operatorWorkTime) * 1000) / 1000;
			}
			if (machineUtilizedTime === 0) {
				dataStructure['"Productivity_utilized_time_sob"'] = 0;
				dataStructure['"Productivity_utilized_time_sub"'] = 0;
			} else {
				dataStructure['"Productivity_utilized_time_sob"'] = Math.round((m3sobTotal / machineUtilizedTime) * 1000) / 1000;
				dataStructure['"Productivity_utilized_time_sub"'] = Math.round((m3subTotal / machineUtilizedTime) * 1000) / 1000;
			}
			if (machineEffectiveTime === 0) {
				dataStructure['"Productivity_E15_time_sob"'] = 0;
				dataStructure['"Productivity_E15_time_sub"'] = 0;
			} else {
				dataStructure['"Productivity_E15_time_sob"'] = Math.round((m3sobTotal / machineEffectiveTime) * 1000) / 1000;
				dataStructure['"Productivity_E15_time_sub"'] = Math.round((m3subTotal / machineEffectiveTime) * 1000) / 1000;
			}
			if (machineProcessing === 0) {
				dataStructure['"Productivity_processing_E0_sob"'] = 0;
				dataStructure['"Productivity_processing_E0_sub"'] = 0;
			} else {
				dataStructure['"Productivity_processing_E0_sob"'] = Math.round((m3sobTotal / machineProcessing) * 1000) / 1000;
				dataStructure['"Productivity_processing_E0_sub"'] = Math.round((m3subTotal / machineProcessing) * 1000) / 1000;
			}
			
			// MACHINE FUEL CONSUMPTION
			if (OPERATIONAL_MONITORING_MACHINE_getWorkTimeObjectType(payload) === 'INDIVIDUAL') {
				dataStructure['"Machine_work_time_category_model"'] = 'Individual';
			}
			if (OPERATIONAL_MONITORING_MACHINE_getWorkTimeObjectType(payload) === 'COMBINED') {
				dataStructure['"Machine_work_time_category_model"'] = 'Combined';
			}
			if (machineCategory === 'HARVESTER') {
			dataStructure['"Harvester_E0_Fuel"'] = getSumOfFuelConsumption(payload, operatorKeyArray[operatorKeyIndex], 'Processing');
			}
			if (machineCategory === 'FORWARDER') {
				dataStructure['"Forwarder_E0_Fuel"'] = getSumOfFuelConsumption(payload, operatorKeyArray[operatorKeyIndex], 'Processing') + getSumOfFuelConsumption(payload, operatorKeyArray[operatorKeyIndex], 'Terrain travel');
			}
			//DEPRECATED
			//dataStructure['"Fuel_processing"'] = getSumOfFuelConsumption(payload, operatorKeyArray[operatorKeyIndex], 'Processing');
			dataStructure['"Fuel_total"'] = getSumOfFuelConsumption(payload, operatorKeyArray[operatorKeyIndex], null);
			
			// ENGINE TIME
			dataStructure['"Engine_time"'] = getSumOfEngineTime(payload, operatorKeyArray[operatorKeyIndex]);
			
			exportDataRowsArray.push(dataStructure);
			
		}
		
		//console.log(exportDataRowsArray);
	}
	
	//DATA ROWS ARRAY DEBUG ->
	
	//console.log(exportDataRowsArray.length);
	//for (var dataRowIndex in exportDataRowsArray) {
	//	console.log(exportDataRowsArray[dataRowIndex]);
	//}
	
	//END OF DATA ROWS DEBUG DEBUG <-
	
	//FILE NAME
	var date = new Date();
	var year = date.getFullYear();
    var	month = date.getMonth() + 1;
	if (month < 10) { month = '0' + month; }
	var day = date.getDate();
    if (day < 10) { day = '0' + day; }
	var hour =	date.getHours();
    if (hour < 10) { hour = '0' + hour; }
	var minute = date.getMinutes();
	if (minute < 10) { minute = '0' + minute; }
	var second = date.getSeconds();
	if (second < 10) { second = '0' + second; }
	//DATE STRING FOR THE FILENAME
	var dateString = year + '' + month + '' + day + '' + hour + '' + minute + '' + second;
	//FILECOUNT STRING
	var fileCount = payloadArray.length;
	var fileCountString;
	if (fileCount === 1) {
		fileCountString = '1_FILE';
	} else {
		fileCountString = fileCount + '_FILES';
	}
	var exportFileName = 'FOBIA_EXPORT_' + dateString + '_' + fileCountString + '.txt';
	
	exportForm(exportFileName, exportDataRowsArray);
}

function getDataStructure() {

	// Export data structure 
	var dataStructure = {};
	// STANDARD EXPORT FORMATTING
	// IDENTIFIERS
	dataStructure['"Data_row"'] = 0;
	dataStructure['"File_name"'] = "";
	dataStructure['"Machine_ID"'] = "";
	dataStructure['"Machine_manufacturer"'] = "";
	dataStructure['"Machine_category"'] = "";
	dataStructure['"Site_ID"'] = "";
	dataStructure['"Start_time"'] = "";
	dataStructure['"End_time"'] = "";
	dataStructure['"Customer"'] = "";
	dataStructure['"Felling_class"'] = "";
	dataStructure['"Operator_ID"'] = "";
	// FORWARDER LOAD COUNT AND FORWARDER AND HARVESTER DRIVEN DISTANCE
	dataStructure['"Driven_total_distance"'] = 0;
	dataStructure['"Mean_Forwarding_distance"'] = 0;
	dataStructure['"Forwarder_loads"'] = 0;
	// FILTER TIMES
	dataStructure['"Filter_time_down"'] = 0;
	dataStructure['"Filter_time_run"'] = 0;
	dataStructure['"Filter_time_min"'] = 0;
	// OPERATOR WORK TIME
	dataStructure['"Operator_Machine_work"'] = 0;
	dataStructure['"Operator_Meal_break"'] = 0;
	dataStructure['"Operator_Planning_and_other"'] = 0;
	dataStructure['"Operator_Travelling_to_work_outside_machine"'] = 0;
	// MACHINE WORK TIME DEPRECATED
	//dataStructure['"Machine_Utilised_time"'] = 0;
	//dataStructure['"Machine_Effective_time_E(15)"'] = 0;
	//dataStructure['"Machine_Productive_time_E0_processing"'] = 0;
	//MACHINE WORK TIME UPDATE
	dataStructure['"Harvester_Utilised_time"'] = 0;
	dataStructure['"Harvester_E15_time"'] = 0;
	dataStructure['"Harvester_E0_productive_time"'] = 0;
	dataStructure['"Forwarder_Utilised_time"'] = 0;
	dataStructure['"Forwarder_E15_time"'] = 0;
	dataStructure['"Forwarder_E0_productive_time"'] = 0;
	// DOWN TIME TOTAL
	dataStructure['"Repair"'] = 0;
	dataStructure['"Maintenance"'] = 0;
	dataStructure['"Disturbance"'] = 0;
	dataStructure['"Other_down_time"'] = 0;
	// DOWN TIME >15 MIN
	// MACHINE DOWN TIME
	dataStructure['"Maintenance (>15 min)"'] = 0;
	dataStructure['"Repair (>15 min)"'] = 0;
	dataStructure['"Waiting_for_repair (>15 min)"'] = 0;
	// MACHINE DISTURABANCE
	dataStructure['"Planning_follow_up_administration (>15 min)"'] = 0;
	dataStructure['"Other disturbance (>15 min)"'] = 0;
	dataStructure['"Unproductive_terrain_work (>15 min)"'] = 0;
	dataStructure['"Other_down_time (>15 min)"'] = 0;
	// TRANSIT
	dataStructure['"Road travel"'] = 0;
	dataStructure['"Trailer_transportation"'] = 0;
	// VOLUME
	dataStructure['"Harvested_volume_Pine_m3sob"'] = 0;
	dataStructure['"Harvested_volume_Spruce_m3sob"'] = 0;
	dataStructure['"Harvested_volume_Birch_m3sob"'] = 0;
	dataStructure['"Harvested_volume_Other_m3sob"'] = 0;
	dataStructure['"Harvested_volume_Total_m3sob"'] = 0;
	dataStructure['"Harvested_volume_Pine_m3sub"'] = 0;
	dataStructure['"Harvested_volume_Spruce_m3sub"'] = 0;
	dataStructure['"Harvested_volume_Birch_m3sub"'] = 0;
	dataStructure['"Harvested_volume_Other_m3sub"'] = 0;
	dataStructure['"Harvested_volume_Total_m3sub"'] = 0;
	dataStructure['"Forwarded_volume_m3sob"'] = 0;
	dataStructure['"Forwarded_volume_m3sub"'] = 0;
	// STEM COUNT
	dataStructure['"Number_of_pine"'] = 0;
	dataStructure['"Number_of_spruce"'] = 0;
	dataStructure['"Number_of_birch"'] = 0;
	dataStructure['"Number_of_other"'] = 0;
	dataStructure['"Number_of_all"'] = 0;
	// AVERAGE VOLUME DM3
	dataStructure['"dm3sob"'] = 0;
	dataStructure['"dm3sub"'] = 0;
	// PRODUCTIVITY
	dataStructure['"Productivity_work_time_sob"'] = 0;
	dataStructure['"Productivity_work_time_sub"'] = 0;
	dataStructure['"Productivity_utilized_time_sob"'] = 0;
	dataStructure['"Productivity_utilized_time_sub"'] = 0;
	dataStructure['"Productivity_E15_time_sob"'] = 0;
	dataStructure['"Productivity_E15_time_sub"'] = 0;
	dataStructure['"Productivity_processing_E0_sob"'] = 0;
	dataStructure['"Productivity_processing_E0_sub"'] = 0;
	// FUEL AND ENGINE TIME
	dataStructure['"Machine_work_time_category_model"'] = '';
	dataStructure['"Fuel_total"'] = 0;
	dataStructure['"Harvester_E0_Fuel"'] = 0;
	dataStructure['"Forwarder_E0_Fuel"'] = 0;
	dataStructure['"Engine_time"'] = 0;
	// RAW DATA
	dataStructure['"Machine_Processing"'] = 0;
	dataStructure['"Machine_Terrain_travel"'] = 0;
	dataStructure['"Machine_Terrain_travel (<15)"'] = 0;
	dataStructure['"Machine_Other_work"'] = 0;
	dataStructure['"Machine_Other_work (<15)"'] = 0;
	dataStructure['"Machine_Down_time"'] = 0;
	dataStructure['"Machine_Down_time (<15)"'] = 0;
	dataStructure['"Disturbance (>15)"'] = 0;
	dataStructure['"Waiting_for_repair"'] = 0;
	dataStructure['"Planning_or_follow_up"'] = 0;
	dataStructure['"Planning_or_follow_up (>15)"'] = 0;
	dataStructure['"Administration_telephone"'] = 0;
	dataStructure['"Administration_telephone (>15)"'] = 0;
	dataStructure['"Unproductive_terrain_work"'] = 0;
	dataStructure['"Trailer_transportation (>15)"'] = 0;
	
	return dataStructure;

}

function setFinalExport(exportFileName, exportDataRowsArray, exportFileFormat, exportFieldSeparator) {
	var jsonObject = exportDataRowsArray[0];
	var exportFileHeaderStringAsArray = Object.keys(jsonObject);
	var finalExportFileHeaderRow = getFinalHeaderRowAsString(null, exportFileHeaderStringAsArray, exportFieldSeparator);
	var finalExportFileDataRows = getFinalExportFileDataRows(exportFileFormat, exportDataRowsArray, exportFileHeaderStringAsArray, exportFieldSeparator);
	var finalExportFileAsString = finalExportFileHeaderRow + '\r\n' + finalExportFileDataRows;
	download_simple(finalExportFileAsString, exportFileName);
}

function getFinalExportFileDataRows(exportFileFormat, exportDataRowsArray, exportFileHeaderStringAsArray, exportFieldSeparator) {
	var finalExportFileDataRows = '';
	var finalExportFileDataRow;
	var columnIndex = 1;
	for (dataRowIndex in exportDataRowsArray) {
		columnIndex = 1;
		finalExportFileDataRow = '';
		for (dataHeaderIndex in exportFileHeaderStringAsArray) {
			if (columnIndex === exportFileHeaderStringAsArray.length) {
				finalExportFileDataRow += exportDataRowsArray[dataRowIndex][exportFileHeaderStringAsArray[dataHeaderIndex]];
			} else {
				finalExportFileDataRow += exportDataRowsArray[dataRowIndex][exportFileHeaderStringAsArray[dataHeaderIndex]] + exportFieldSeparator;
			}
			columnIndex++;
		}
		finalExportFileDataRows += finalExportFileDataRow + '\r\n';
	}
	return finalExportFileDataRows;
}

function getFinalHeaderRowAsString(exportFileFormat, exportFileHeaderStringAsArray, exportFieldSeparator) {
	var headerRow = '';
	var rowIndex = 1;
	for (var arrayIndex in exportFileHeaderStringAsArray) {
		if (rowIndex === exportFileHeaderStringAsArray.length) {
			headerRow += exportFileHeaderStringAsArray[arrayIndex];
		} else {
			headerRow += exportFileHeaderStringAsArray[arrayIndex] + exportFieldSeparator;
		}
		rowIndex++;
	}
	
	headerRow = headerRow.replace(/"/g,'');
	
	//console.log(headerRow);
	return headerRow;
	
}

function deprecated_setFinalExport(exportFileName, exportDataRowsArray, exportFieldSeparator) {
	
	var finalExportDataLines = [];
	var exportFileAsArray = exportFile.split('\r\n');
	var valueTokens = [];
	var dataLine = [];
	
	if (selectedExportFieldIndices.length > 0) {
		for (var index in exportFileAsArray) {
			valueTokens = exportFileAsArray[index].split(separator);
			dataLine = [];
			for (var exportFieldIndex in selectedExportFieldIndices) {
				dataLine.push(valueTokens[selectedExportFieldIndices[exportFieldIndex]]);
			}
			finalExportDataLines.push(dataLine.join(separator));
		}
		exportBlob = finalExportDataLines.join('\r\n');
	} else {
		exportBlob = exportFile;
	}
	
	download_simple(exportBlob, exportFileName);
	if (document.getElementById('export-form-keep-active').checked === false) {
		location.href = '#content';
	}
	
}

function deprecated_exportBuilder(payloadArray) {

	console.clear();
	
	var HEADER_LINE = '';
	var separator;
	var DATA_LINE = '';
	var EXPORT_DATA_LINES = [];
	var EXPORT_BLOB = [];
	var exportBlob;
	
	var jsonObject;
	var filename;
	var payload;
	
	//METADATA VARIABLES
	var operatorKeys;
	var operatorKey;
	var operatorCount;
	
	var creationDate;
	var areaUnit;
	var lengthUnit;
	var volumeUnit;
	var weightUnit;
	var countryCode;
	var machineCategory;
	var machineBaseManufacturer;
	var machineBaseModel;
	var machineHeadManufacturer;
	var machineHeadModel;
	var applicationVersion;
	var machineTotalEngineTime;
	var machineTotalDrivenDistance;
	var machineTotalFuelConsumption;
	
	//SITE VARIABLES
	var loggingFormCode;
	var loggingFormDescription;
	var latitude;
	var longitude;
	var forestOwnerObject;
	var forestOwnerBusinessName;
	var forestSertification;
	var loggingOrganisation;
	var startDateOnSite;
	var endDateOnSite;
	
	//MONITORING SETTINGS VARIABLES
	var filterTimeDown;
	var filterTimeRun;
	var filterTimeMinimum;
	
	// HEADER
	separator = '\t';
	HEADER_LINE = '';
	HEADER_LINE = 'file name'                      + separator +
				  'operator key'                   + separator +
				  'creation date'                  + separator +
				  'area unit'                      + separator +
				  'length unit'                    + separator +
				  'volume unit'                    + separator +
				  'weight unit'                    + separator +
				  'country code'                   + separator +
				  'machine category'               + separator +
				  'machine base manufacturer'      + separator +
				  'machine base model'             + separator +
				  'machine head manufacturer'      + separator +
				  'machine head model'             + separator +
				  'application version'            + separator +
				  'machine total engine time'      + separator +
				  'machine total driven distance'  + separator +
				  'machine total fuel consumption' + separator +
				  'logging form code'              + separator +
				  'logging form description'       + separator +
	              'latitude'           			   + separator +
				  'longitude'           		   + separator +
				  'forest owner'           		   + separator +
				  'forest sertification'           + separator +
				  'logging organisation'           + separator +
				  'start date on site'             + separator +
				  'end date on site';
	
	
	//Filter time (Monitoring Settings Object) headers
	//The whole payloadArray needs to be iterated in order to get the MAX MONITORING SETTINGS COUNT for data header
	var monitoringSettingsObject;
	var monitoringSettingsObjectCountNew;
	var monitoringSettingsObjectCountMAX = 0;
	for (var doc in payloadArray) {
		payload = payloadArray[doc];
		monitoringSettingsObject = OPERATIONAL_MONITORING_MACHINE_getMonitoringSettings(payload);
		if (OPERATIONAL_MONITORING_MACHINE_getMonitoringSettingsReturnType(payload) === 'Object') {
			monitoringSettingsObjectCountNew = 1;
		}
		if (OPERATIONAL_MONITORING_MACHINE_getMonitoringSettingsReturnType(payload) === 'Array') {
			monitoringSettingsObjectCountNew = monitoringSettingsObject.length;
		}
		if (monitoringSettingsObjectCountNew > monitoringSettingsObjectCountMAX) {
			monitoringSettingsObjectCountMAX = monitoringSettingsObjectCountNew;
		}
	}
	for (var i = 1; i <= monitoringSettingsObjectCountMAX; i++) {
		HEADER_LINE += separator + 'filter time down ' + i + separator + 'filter time run ' + i + separator + 'filter time minimum ' + i;
	}
	
	for (var doc in payloadArray) {
		
		jsonObject = JSON.parse(payloadArray[doc]);
		filename = jsonObject.filename;
		//log(filename);
		payload = payloadArray[doc];
		
		operatorKeys = OPERATIONAL_MONITORING_MACHINE_getOperatorKeys(payload);
		operatorCount = operatorKeys.length;
		
		for (operator in operatorKeys) {
			
			//METADATA
			DATA_LINE = filename + separator;
			operatorKey = operatorKeys[operator];
			DATA_LINE += operatorKey + separator;
			creationDate = OPERATIONAL_MONITORING_HEADER_getValue(payload, 'CreationDate');
			DATA_LINE += creationDate + separator;
			areaUnit = OPERATIONAL_MONITORING_ROOT_getValue(payload, 'areaUnit');
			DATA_LINE += areaUnit + separator;
			lengthUnit = OPERATIONAL_MONITORING_ROOT_getValue(payload, 'lengthUnit');
			DATA_LINE += lengthUnit + separator;
			volumeUnit = OPERATIONAL_MONITORING_ROOT_getValue(payload, 'volumeUnit');
			DATA_LINE += volumeUnit + separator;
			weightUnit = OPERATIONAL_MONITORING_ROOT_getValue(payload, 'weightUnit');
			DATA_LINE += weightUnit + separator;
			countryCode = OPERATIONAL_MONITORING_HEADER_getValue(payload, 'CountryCode');
			DATA_LINE += countryCode + separator;
			machineCategory = OPERATIONAL_MONITORING_MACHINE_CATEGORY_getValue(payload);
			DATA_LINE += machineCategory + separator;
			machineBaseManufacturer = OPERATIONAL_MONITORING_MACHINE_getValue(payload, 'MachineBaseManufacturer');
			DATA_LINE += machineBaseManufacturer + separator;
			machineBaseModel = OPERATIONAL_MONITORING_MACHINE_getValue(payload, 'MachineBaseModel');
			DATA_LINE += machineBaseModel + separator;
			machineHeadManufacturer = OPERATIONAL_MONITORING_MACHINE_getValue(payload, 'MachineHeadManufacturer');
			DATA_LINE += machineHeadManufacturer + separator;
			machineHeadModel = OPERATIONAL_MONITORING_MACHINE_getValue(payload, 'MachineHeadModel');
			DATA_LINE += machineHeadModel + separator;
			applicationVersion = OPERATIONAL_MONITORING_HEADER_getValue(payload, 'ApplicationVersionCreated');
			DATA_LINE += applicationVersion + separator;
			machineTotalEngineTime = OPERATIONAL_MONITORING_MACHINE_getValue(payload, 'MachineEngineTime');
			DATA_LINE += machineTotalEngineTime + separator;
			machineTotalDrivenDistance = OPERATIONAL_MONITORING_MACHINE_getValue(payload, 'MachineDrivenDistance');
			DATA_LINE += machineTotalDrivenDistance + separator;
			machineTotalFuelConsumption = OPERATIONAL_MONITORING_MACHINE_getValue(payload, 'MachineFuelConsumption');
			DATA_LINE += machineTotalFuelConsumption + separator;
			
			//SITE INFORMATION
			var objectDefinition = OPERATIONAL_MONITORING_MACHINE_getObjectDefinition(payload);
			if (getJsonReturnType(objectDefinition) === 'Object') {
				var loggingForm = OPERATIONAL_MONITORING_MACHINE_OBJECT_DEFINITION_getLoggingForm(payload);
				loggingFormCode = loggingForm.LoggingFormCode;
				DATA_LINE += loggingFormCode + separator;
				loggingFormDescription = loggingForm.LoggingFormDescription;
				DATA_LINE += loggingFormDescription + separator;
				latitude = OPERATIONAL_MONITORING_MACHINE_POSITION_getValue(payload, 'Latitude');
				DATA_LINE += latitude + separator;
				longitude = OPERATIONAL_MONITORING_MACHINE_POSITION_getValue(payload, 'Longitude');
				DATA_LINE += longitude + separator;
				forestOwnerObject =  GENERAL_getValue(objectDefinition, 'ForestOwner');
				forestOwnerBusinessName = GENERAL_getValue(forestOwnerObject, 'BusinessName');
				if (!forestOwnerBusinessName || forestOwnerBusinessName === '') {
					forestOwnerBusinessName = '-';
				}
				DATA_LINE += forestOwnerBusinessName + separator;
				forestSertification = GENERAL_getValue(objectDefinition, 'ForestCertification');
				DATA_LINE += forestSertification + separator;
				loggingOrganisation = OPERATIONAL_MONITORING_MACHINE_OBJECT_DEFINITION_getLoggingOrganisation(payload);
				DATA_LINE += loggingOrganisation + separator;
				startDateOnSite = GENERAL_getValue(objectDefinition, 'StartDate');
				if (!startDateOnSite) {
					startDateOnSite = '-';
				}
				DATA_LINE += startDateOnSite + separator;
				endDateOnSite = GENERAL_getValue(objectDefinition, 'EndDate');
				if (!endDateOnSite) {
					endDateOnSite = '-';
				}
				DATA_LINE += endDateOnSite;
			}
			
			//MONITORING SETTINGS
			var monitoringSettings = OPERATIONAL_MONITORING_MACHINE_getMonitoringSettings(payload);
			if (OPERATIONAL_MONITORING_MACHINE_getMonitoringSettingsReturnType(payload) === 'Object') {
				DATA_LINE += separator + OPERATIONAL_MONITORING_MACHINE_MONITORING_SETTINGS_getMonitoringFilterTimeDown(monitoringSettings);
				DATA_LINE += separator + OPERATIONAL_MONITORING_MACHINE_MONITORING_SETTINGS_getMonitoringFilterTimeRun(monitoringSettings);
				DATA_LINE += separator + OPERATIONAL_MONITORING_MACHINE_MONITORING_SETTINGS_getMonitoringFilterTimeMinimum(monitoringSettings);
			}
			if (OPERATIONAL_MONITORING_MACHINE_getMonitoringSettingsReturnType(payload) === 'Array') {
				for (var objectIndex in monitoringSettings) {
					DATA_LINE += separator + OPERATIONAL_MONITORING_MACHINE_MONITORING_SETTINGS_getMonitoringFilterTimeDown(monitoringSettings[objectIndex]);
					DATA_LINE += separator + OPERATIONAL_MONITORING_MACHINE_MONITORING_SETTINGS_getMonitoringFilterTimeRun(monitoringSettings[objectIndex]);
					DATA_LINE += separator + OPERATIONAL_MONITORING_MACHINE_MONITORING_SETTINGS_getMonitoringFilterTimeMinimum(monitoringSettings[objectIndex]);
				}
			}
			
			EXPORT_DATA_LINES.push(DATA_LINE);
			
		}
	}
	
	exportBlob = HEADER_LINE + '\r\n' + EXPORT_DATA_LINES.join('\r\n')
	log(exportBlob);
	
	//FILE NAME
	var date = new Date();
	var year = date.getFullYear();
    var	month = date.getMonth() + 1;
	if (month < 10) { month = '0' + month; }
	var day = date.getDate();
    if (day < 10) { day = '0' + day; }
	var hour =	date.getHours();
    if (hour < 10) { hour = '0' + hour; }
	var minute = date.getMinutes();
	if (minute < 10) { minute = '0' + minute; }
	var second = date.getSeconds();
	if (second < 10) { second = '0' + second; }
	//DATE STRING FOR THE FILENAME
	var dateString = year + '' + month + '' + day + '' + hour + '' + minute + '' + second;
	//FILECOUNT STRING
	var fileCount = payloadArray.length;
	var fileCountString;
	if (fileCount === 1) {
		fileCountString = '1_FILE';
	} else {
		fileCountString = fileCount + '_FILES';
	}
	var exportFileName = 'FOBIA_EXPORT_' + dateString + '_' + fileCountString + '.txt';
	log(exportFileName);
	
	exportForm(HEADER_LINE, separator, exportBlob, exportFileName);
	
	//document.getElementById('export-content').innerHTML = '<h2 class="major">Export</h2>';
	//download(exportBlob , 'test.txt');
	
	
}

function deprecated_setFinalExport(selectedExportFieldIndices, exportFile, exportFileHeaders, exportFileName) {
	
	var finalExportDataLines = [];
	var exportFileAsArray = exportFile.split('\r\n');
	var valueTokens = [];
	var dataLine = [];
	
	if (selectedExportFieldIndices.length > 0) {
		for (var index in exportFileAsArray) {
			valueTokens = exportFileAsArray[index].split(separator);
			dataLine = [];
			for (var exportFieldIndex in selectedExportFieldIndices) {
				dataLine.push(valueTokens[selectedExportFieldIndices[exportFieldIndex]]);
			}
			finalExportDataLines.push(dataLine.join(separator));
		}
		exportBlob = finalExportDataLines.join('\r\n');
	} else {
		exportBlob = exportFile;
	}
	
	download_simple(exportBlob, exportFileName);
	if (document.getElementById('export-form-keep-active').checked === false) {
		location.href = '#content';
	}
	
}

function download_simple(data, filename) {

	var blob = new Blob([data], { type: 'text/plain;charset=utf-8' });
    anchor = document.createElement('a');
	anchor.download = filename;
	anchor.href = window.URL.createObjectURL(blob);
	anchor.dataset.downloadurl = ['text/plain', anchor.download, anchor.href].join(':');
	document.body.appendChild(anchor);
	anchor.click();
	document.body.removeChild(anchor);
	
}


// DEPRECATED: Function for converting string data to a file object and download it
function download(data, filename) {
    var file = new Blob([data], {type: 'text/plain;charset=windows-1250'});
    if (window.navigator.msSaveOrOpenBlob) // IE10+
        window.navigator.msSaveOrOpenBlob(file, filename);
    else { // Others
        var a = document.createElement("a"), url = URL.createObjectURL(file);
        a.href = url;
        a.download = filename;
        document.body.appendChild(a);
        a.click();
        setTimeout(function() {
            document.body.removeChild(a);
            window.URL.revokeObjectURL(url);
        }, 0); 
    }
	
}