
function getDateTimeAsArray(dateTime) { 

	var dateArray = [];
	dateArray.push(getYear(dateTime));
	dateArray.push(getMonth(dateTime));
	dateArray.push(getDay(dateTime));
	dateArray.push(getHour(dateTime));
	dateArray.push(getMinute(dateTime));
	dateArray.push(getSecond(dateTime));
	return dateArray;

}

function getDateTimeInMilliseconds(dateTime) {
	var dateTimeInDateFormat = new Date(dateTime);
	return (dateTimeInDateFormat.getTime());
}

function getSecondsInHours(seconds) {
	var secondsInHours = Math.round( (seconds/3600) * 100 ) / 100;
	return secondsInHours;
}

function getDateTimePlusSecondsAsDateTime(dateTime, seconds) { 

	//dateTime = '2018-11-29T13:06:53.383+02:00';
	//seconds = 60;

	var dateTimeInDateFormat = new Date(dateTime);
	var dateTimeInMilliseconds = dateTimeInDateFormat.getTime();
	var sumOfTimes = dateTimeInMilliseconds + (seconds * 1000);
	var ntd = new Date(sumOfTimes);
	var nYear = ntd.getFullYear();
	var nMonth = ntd.getMonth() + 1;
	if (nMonth < 10) { nMonth = '0' + nMonth; }
	var nDay = ntd.getDate();
	if (nDay < 10) { nDay = '0' + nDay; }
	var nHour = ntd.getHours();
	if (nHour < 10) { nHour = '0' + nHour; }
	var nMinute = ntd.getMinutes();
	if (nMinute < 10) { nMinute = '0' + nMinute; }
	var nSecond = ntd.getSeconds();
	if (nSecond < 10) { nSecond = '0' + nSecond; }
	var nMillisecond = ntd.getMilliseconds();
	//var nTimeZoneOffset = Math.abs(ntd.getTimezoneOffset());
	var timeZone = dateTime.substring(dateTime.length - 6 , dateTime.length + 6);
	
	//console.log(ntd);
	//console.log(timeZone);
	return (nYear + '-' + nMonth + '-' + nDay + 'T' + nHour + ':' + nMinute + ':' + nSecond + '.' + nMillisecond + timeZone);

}

function getMillisecondsAsDate(milliseconds) {
	var dateTime = new Date(milliseconds);
	var year_string = dateTime.getFullYear();
	var month_string = dateTime.getMonth();
	month_string += 1;
	if (month_string < 10) {
		month_string = '0' + month_string;
	}
	var day_string = dateTime.getDate();
	if (dateTime.getDate() < 10) {
		day_string = '0' + day_string;
	}
	return year_string + '-' + month_string + '-' + day_string;
}

function getMillisecondsAsDateTime(milliseconds) {
	var dateTime = new Date(milliseconds);
	var year_string = dateTime.getFullYear();
	var month_string = dateTime.getMonth();
	month_string += 1;
	if (month_string < 10) {
		month_string = '0' + month_string;
	}
	var day_string = dateTime.getDate();
	if (dateTime.getDate() < 10) {
		day_string = '0' + day_string;
	}
	var hour_string = dateTime.getHours();
	if (dateTime.getHours() < 10) {
		hour_string = '0' + hour_string;
	}
	var minute_string = dateTime.getMinutes();
	if (dateTime.getMinutes() < 10) {
		minute_string = '0' + minute_string;
	}
	var second_string = dateTime.getSeconds();
	if (dateTime.getSeconds() < 10) {
		second_string = '0' + second_string;
	}
	return year_string + '-' + month_string + '-' + day_string + ' ' + hour_string + ':' + minute_string + ':' + second_string;
}

function getDatesBetween(startDate, endDate) {
	
	var datesBetweenArray = [];
	var datesItem = [];
	
	//startDate = '2018-11-29T13:06:53.383+02:00';
	//endDate = '2018-12-04T13:40:10.876+02:00';
	
	//console.log(startDate);
	//console.log(endDate);
	
	var startYear = getYear(startDate);
	var startMonth = getMonth(startDate);
	//console.log('START MONTH: ' + startMonth);
	var startDay = getDay(startDate);
	
	var endYear = getYear(endDate);
	var endMonth = getMonth(endDate);
	var endDay = getDay(endDate);
	
	var date1 = new Date(startMonth + '/' + startDay + '/' + startYear);
	var date2 = new Date(endMonth + '/' + endDay + '/' + endYear);
	var timeDiff = Math.abs(date2.getTime() - date1.getTime());
	var diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
	//console.log(diffDays);
	
	var nextDate;
	
	datesItem.push(getDayString(new Date(startMonth + '/' + startDay + '/' + startYear).getDay()) + ' ' + new Date(startMonth + '/' + startDay + '/' + startYear).getFullYear() + '-' + (new Date(startMonth + '/' + startDay + '/' + startYear).getMonth() + 1) + '-' + new Date(startMonth + '/' + startDay + '/' + startYear).getDate());
	datesItem.push(new Date(startMonth + '/' + startDay + '/' + startYear).getFullYear());
	datesItem.push(new Date(startMonth + '/' + startDay + '/' + startYear).getMonth() + 1);
	//console.log('CALC MONTH: ' + new Date(startMonth + '/' + startDay + '/' + startYear).getMonth());
	datesItem.push(new Date(startMonth + '/' + startDay + '/' + startYear).getDate());
	datesBetweenArray.push(datesItem);
	datesItem = [];
	
	for (var addMs = (1000 * 3600 * 24); addMs < (diffDays + 1) * (1000 * 3600 * 24); addMs += (1000 * 3600 * 24)) {
		nextDate = Math.abs(date1.getTime() + addMs);
		datesItem.push(getDayString(new Date(nextDate).getDay()) + ' ' + new Date(nextDate).getFullYear() + '-' + (new Date(nextDate).getMonth() + 1) + '-' + new Date(nextDate).getDate());
		datesItem.push(new Date(nextDate).getFullYear());
		datesItem.push(new Date(nextDate).getMonth() + 1);
		datesItem.push(new Date(nextDate).getDate());
		datesBetweenArray.push(datesItem);
		datesItem = [];
	}

	return datesBetweenArray;
	
}

function getDayString(dayNumber) {
	switch (dayNumber) {
		case 0:
			return 'Sunday';
		case 1:
			return 'Monday';
		case 2:
			return 'Tuesday';
		case 3:
			return 'Wednesday';
		case 4:
			return 'Thursday';
		case 5:
			return 'Friday';
		case 6:
			return 'Saturday';
	}
}

function getDaysInMonth(year, month) {
	var d = new Date(year, month + 1, 0);
	var dateString = d.toString();
	var dateTokens = dateString.split(' ');
	console.log(dateTokens[2]);
}


function getSecondsInTotalHoursAndMinutes(seconds) {
	var hours = seconds / (60 * 60);
	var remainder = hours - Math.floor(Math.abs(hours));
	var minutes = remainder * 60;
	return parseInt(hours) + ' hours ' + parseInt(minutes) + ' minutes';
}

function getSecondsInTotalHoursMinutesSeconds(seconds) {
	var hours = seconds / (60 * 60);
	var remainder = hours - Math.floor(Math.abs(hours));
	var minutes = remainder * 60;
	remainder = minutes - Math.floor(Math.abs(minutes));
	var seconds = remainder * 60;
	return parseInt(hours) + ' hours ' + parseInt(minutes) + ' minutes ' + parseInt(seconds) + ' seconds';
}

function getSecondsInHHmmss(seconds) {
	var dateFromSeconds = new Date(0,0,0,0,0,seconds,0);
	var hours = dateFromSeconds.getHours();
	var minutes = dateFromSeconds.getMinutes();
	var seconds = dateFromSeconds.getSeconds();
	return hours + ' hours ' + minutes + ' minutes ' + seconds + ' seconds';
}

function getTimePlusSeconds(timeVariable, secondVariable) {
	var timeVariableTokens = timeVariable.split(':');
	var hour = 0;
	var minute = 0;
	var second = 0;
	var hourFromSecondVariable = 0;
	var minuteFromSecondVariable = 0;
	var secondFromSecondVariable = 0;
	var newHour;
	var newMinute;
	var newSecond;
	switch (timeVariableTokens.length) {
		case 3:
			hour   = parseInt(timeVariableTokens[0]);
			minute = parseInt(timeVariableTokens[1]);
			second = parseInt(timeVariableTokens[2]);
			break;
		case 2:
			hour   = parseInt(timeVariableTokens[0]);
			minute = parseInt(timeVariableTokens[1]);
			second = 0;
			break;
		case 1:
			hour   = parseInt(timeVariableTokens[0]);
			minute = 0;
			second = 0;
			break;
		default:
			hour   = 0;
			minute = 0;
			second = 0;
	}
	var timeVariableInMilliseconds = (hour * 60 * 60 + minute * 60 + second) * 1000;
	var secondVariableInMilliseconds = parseInt(secondVariable) * 1000;
	var newTimeInMilliseconds = timeVariableInMilliseconds + secondVariableInMilliseconds;
	var newDateTime = new Date(0,0,0,0,0,0, newTimeInMilliseconds);
	timeVariableTokens = newDateTime.toString().split(' ');
	var newTime = timeVariableTokens[4];
	return newTime;
}

function getDate(ISO_dateTime) {
	return ISO_dateTime.substring(0,10);
}

function getTime(ISO_dateTime) {
	return ISO_dateTime.substring(11,19);
}

function getYear(ISO_dateTime) {
	return ISO_dateTime.substring(0,4);
}

function getMonth(ISO_dateTime) {
	return ISO_dateTime.substring(5,7);
}

function getDay(ISO_dateTime) {
	return ISO_dateTime.substring(8,10);
}

function getHour(ISO_dateTime) {
	return ISO_dateTime.substring(11,13);
}

function getMinute(ISO_dateTime) {
	return ISO_dateTime.substring(14,16);
}

function getSecond(ISO_dateTime) {
	return ISO_dateTime.substring(17,19);
}

function getMillisecond(ISO_dateTime) {
	
	if (ISO_dateTime.length < 29) {
		return '000';
	} else {
		return ISO_dateTime.substring(20,23);
	}
}

function uniq(a) { 
    var prims = {"boolean":{}, "number":{}, "string":{}}, objs = [];

    return a.filter(function(item) {
        var type = typeof item;
        if(type in prims)
            return prims[type].hasOwnProperty(item) ? false : (prims[type][item] = true);
        else
            return objs.indexOf(item) >= 0 ? false : objs.push(item);
    });
}

function set_notification_on_export_form(message) {
	document.getElementById('export-form-notification-area').innerHTML = '<p>' + message + '</p>';
}

function filetype(filename) {

	var fileType;
	var hasDot;
	var fileExtension;
	var dotPosition = filename.indexOf('.');
	var response = '';
	
	if (dotPosition === -1) {
		fileType = 'DIR';
		hasDot = false;
		response = fileType;
	} else {
		fileType = 'FILE';
		hasDot = true;
	}
	
	if (hasDot) {
		fileExtension = filename.substring(dotPosition + 1, filename.length);
		response = fileExtension;
	}
	
	return response;
	
}

/*
 *  OBSOLETE. Functionality moved to trash
 */
function oneDimensionalArrayAggregator(inputArray, aggregateKey) {
	
	var jsonObject;
	
	var aggregateKeysArray = [];
	var uniqueAggregateKeysArray = [];
	
	var volumeObject;
	var volumeObjects;
	var volumeCategoriesArray = [];
	var uniqueVolumeCategoriesArray = [];
	
	for (var dataItem in inputArray) {
		jsonObject = JSON.parse(inputArray[dataItem]);
		aggregateKeysArray.push(jsonObject[aggregateKey]);
		//volumeObjects = jsonObject.totalVolume;
		//for (volumeObject in volumeObjects) {
		//	volumeCategoriesArray.push(volumeObjects[volumeObject].harvestedLogsVolumeCategory);
		//}
	}
	
	// Unique volume categories
	//for(var i = 0;i < volumeCategoriesArray.length; i++){
    //    if(uniqueVolumeCategoriesArray.indexOf(volumeCategoriesArray[i]) === -1){
    //        uniqueVolumeCategoriesArray.push(volumeCategoriesArray[i]);
    //    }
    //}
	
	// CONSOLE LOG UNIQUE VOLUME CATEGORIES
	//for (var dataItem in uniqueVolumeCategoriesArray) {
	//	console.log(uniqueVolumeCategoriesArray[dataItem]);
	//}
	
	// Unigue AGGREGATOR_KEY categories
	for(var i = 0;i < aggregateKeysArray.length; i++){
        if(uniqueAggregateKeysArray.indexOf(aggregateKeysArray[i]) === -1){
            uniqueAggregateKeysArray.push(aggregateKeysArray[i]);
        }
    }
	
	var returnArray = [];
	var numberOfHarvestedStemsSum = 0;
	var totalVolumeSum = 0;
	var volumeCategoryAggregateArray = [];
	var m3subSum = 0;
	var m3sobSum = 0;
	
	for (var uniqueKey in uniqueAggregateKeysArray) {
		numberOfHarvestedStemsSum = 0;
		m3subSum = 0;
		m3sobSum = 0;
		for (var dataItem in inputArray) {
			jsonObject = JSON.parse(inputArray[dataItem]);
			if (uniqueAggregateKeysArray[uniqueKey] === jsonObject[aggregateKey]) {
				numberOfHarvestedStemsSum += parseInt(jsonObject.numberOfHarvestedStems);
				for (var categoryItemIndex in jsonObject.totalVolume) {
					volumeObject = jsonObject.totalVolume[categoryItemIndex];
					if (volumeObject.harvestedLogsVolumeCategory === 'm3sub') {
						m3subSum += parseFloat(volumeObject.harvestedLogsVolumeValue);
						//console.log(jsonObject[aggregateKey] + ' sub ' + parseFloat(volumeObject.harvestedLogsVolumeValue));
					}
					if (volumeObject.harvestedLogsVolumeCategory === 'm3sob') {
						m3sobSum += parseFloat(volumeObject.harvestedLogsVolumeValue);
						//console.log(jsonObject[aggregateKey] + ' sob ' + parseFloat(volumeObject.harvestedLogsVolumeValue));
					}
				}
			}
		}
		returnArray.push('{"speciesGroupName":"' + uniqueAggregateKeysArray[uniqueKey] + '", "numberOfHarvestedStems":' + numberOfHarvestedStemsSum + ', "volumeCategory":[{"volumeCategory":"m3sub", "volumeSum":' + m3subSum + '}, {"volumeCategory":"m3sob", "volumeSum":' + m3sobSum + '}]}');
	}
	
	return returnArray;
}
